# GenericLinearAlgebra.jl
[![CI](https://github.com/JuliaLinearAlgebra/GenericLinearAlgebra.jl/actions/workflows/ci.yml/badge.svg)](https://github.com/JuliaLinearAlgebra/GenericLinearAlgebra.jl/actions/workflows/ci.yml)
[![codecov](https://codecov.io/gh/JuliaLinearAlgebra/GenericLinearAlgebra.jl/branch/master/graph/badge.svg?token=eO37qmAboR)](https://codecov.io/gh/JuliaLinearAlgebra/GenericLinearAlgebra.jl)
[![](https://img.shields.io/badge/docs-stable-blue.svg)](https://JuliaLinearAlgebra.github.io/GenericLinearAlgebra.jl/stable)

### A fresh approach to numerical linear algebra in Julia

The purpose of this package is partly to extend linear algebra functionality in base to cover generic element types, e.g. `BigFloat` and `Quaternion`, and partly to be a place to experiment with fast linear algebra routines written in Julia (except for optimized BLAS). It is my hope that it is possible to have implementations that are generic, fast, and readable.

So far, this has mainly been my playground but you might find some of the functionality here useful. The package has a generic implementation of a singular value solver which will make it possible to compute `norm` and `cond` of matrices of `BigFloat`. Hence

```jl
julia> using GenericLinearAlgebra

julia> A = big.(randn(10,10));

julia> cond(A)
1.266829904721752610946505846921202851190952179974780602509001252204638657237828e+03

julia> norm(A)
6.370285271475041598951769618847832429030388948627697440637424244721679386430589
```

The package also includes functions for the blocked Cholesky and QR factorization, the self-adjoint (symmetric) and the general eigenvalue problem. These routines can be accessed by fully qualifying the names

```jl
julia> using GenericLinearAlgebra

julia> A = randn(1000,1000); A = A'A;

julia> cholesky(A);

julia> @time cholesky(A);
  0.013036 seconds (16 allocations: 7.630 MB)

julia> GenericLinearAlgebra.cholRecursive!(copy(A), Val{:L});

julia> @time GenericLinearAlgebra.cholRecursive!(copy(A), Val{:L});
  0.012098 seconds (7.00 k allocations: 7.934 MB)
```

using Test, GenericLinearAlgebra, LinearAlgebra

@testset "The General eigenvalue problem" begin

    cplxord = t -> (real(t), imag(t))

    @testset "General eigen problem with n=$n and element type=$T" for n in (10, 23, 100),
        T in (Float64, Complex{Float64})

        A = randn(T, n, n)
        vGLA = GenericLinearAlgebra._eigvals!(copy(A))
        vLAPACK = eigvals(A)
        vBig = eigvals(big.(A)) # not defined in LinearAlgebra so will dispatch to the version in GenericLinearAlgebra
        @test sort(vGLA, by = cplxord) ≈ sort(vLAPACK, by = cplxord)
        @test sort(vGLA, by = cplxord) ≈ sort(complex(eltype(A)).(vBig), by = cplxord)
        @test issorted(vBig, by = cplxord)

        if T <: Complex
            @testset "Rayleigh shifts" begin
                @test sort(
                    GenericLinearAlgebra._eigvals!(
                        GenericLinearAlgebra._schur!(copy(A), shiftmethod = :Rayleigh),
                    ),
                    by = t -> (real(t), imag(t)),
                ) ≈ sort(eigvals(A), by = t -> (real(t), imag(t)))
            end
        end
    end

    @testset "make sure that solver doesn't hang" begin
        for i = 1:1000
            A = randn(8, 8)
            sort(abs.(GenericLinearAlgebra._eigvals!(copy(A)))) ≈ sort(abs.(eigvals(A)))
        end
    end

    @testset "Convergence in corner cases. Issue 29." begin
        function H(n::Int)
            H = zeros(2n, 2n)
            for i = 1:2:2n
                H[i, i+1] = 1
                H[i+1, i] = 1
            end
            H
        end

        function E(n::Int)
            E = zeros(2n, 2n)
            for i = 1:(n-1)
                E[2i+1, 2i] = 1
            end
            E[1, 2n] = 1
            E
        end

        my_matrix(n::Int, η::Float64 = 1e-9) = H(n) .+ η .* E(n)

        A = my_matrix(4, 1e-3)
        @test sort(
            GenericLinearAlgebra._eigvals!(GenericLinearAlgebra._schur!(copy(A))),
            by = t -> (real(t), imag(t)),
        ) ≈ sort(eigvals(A), by = t -> (real(t), imag(t)))
    end

    @testset "Convergence in with 0s Issue 58." begin
        A = [0.0 1.0 0.0; -1.0 0.0 0.0; 0.0 0.0 0.0]
        @test sort(
            GenericLinearAlgebra._eigvals!(GenericLinearAlgebra._schur!(copy(A))),
            by = t -> (real(t), imag(t)),
        ) ≈ sort(eigvals(A), by = t -> (real(t), imag(t)))
        B = [0.0 0.0 0.0; 0.0 0.0 1.0; 0.0 -1.0 0.0]
        @test sort(
            GenericLinearAlgebra._eigvals!(GenericLinearAlgebra._schur!(copy(B))),
            by = t -> (real(t), imag(t)),
        ) ≈ sort(eigvals(B), by = t -> (real(t), imag(t)))
    end

    @testset "Extract Schur factor" begin
        A = randn(5, 5)
        @test sum(eigvals(schur(A).T)) ≈ sum(eigvals(Float64.(schur(big.(A)).T)))
        @test sum(eigvals(schur(A).Schur)) ≈ sum(eigvals(Float64.(schur(big.(A)).Schur)))
    end

    @testset "Issue 63" begin
        A = [
            1 2 1 1 1 1
            0 1 0 1 0 1
            1 1 2 0 1 0
            0 1 0 2 1 1
            1 1 1 0 2 0
            0 1 1 1 0 2
        ]

        z1 = [complex(1, sqrt(big(3))), complex(1, -sqrt(big(3)))]
        z2 = [
            4 * 2^(big(2) / 3) / complex(5, 3 * sqrt(big(111)))^(big(1) / 3),
            complex(5, 3 * sqrt(big(111)))^(big(1) / 3) / 2^(big(2) / 3),
        ]

        truevals =
            real.([
                (7 - transpose(z1) * z2),
                3,
                3,
                3,
                (7 - adjoint(z1) * z2),
                (7 + [2, 2]' * z2),
            ]) / 3

        @test eigvals(big.(A)) ≈ truevals
    end

    Demmel(η) = [
        0 1 0 0
        1 0 η 0
        0 -η 0 1
        0 0 1 0
    ]

    @testset "Demmel matrix" for t in (1e-10, 1e-9, 1e-8)
        # See "Sandia technical report 96-0913J: How the QR algorithm fails to converge and how fix it"
        A = Demmel(t)
        vals = GenericLinearAlgebra._eigvals!(GenericLinearAlgebra._schur!(A, maxiter = 35))
        @test abs.(vals) ≈ ones(4)
    end

    function Hevil2(θ, κ, α, γ)
        # Eq (13) and (14)
        β = ω = 0.0
        ν = cos(θ) * cos(2γ) + cos(α + β + ω) * sin(2γ) * κ / 2
        σ = 1 + κ * sin(2γ) * cos(α + β + ω - θ) + κ^2 * sin(γ)^2
        μ = -sin(θ) * cos(2γ) - sin(α + β + ω) * sin(2γ) * κ / 2
        ρ = sqrt(σ - ν^2)

        return [
            ν (cos(2θ)-ν^2)/ρ μ/ρ*(cos(2θ)-ν^2+ρ^2)/sqrt(ρ^2 - μ^2) (-2*μ*ν-sin(2 * θ))/sqrt(ρ^2 - μ^2)
            ρ -ν-sin(2 * θ)*μ/ρ^2 -μ/ρ^2*(μ*sin(2 * θ)+2*ν*ρ^2)/sqrt(ρ^2 - μ^2) -μ/ρ*(cos(2 * θ)-ν^2+ρ^2)/sqrt(ρ^2 - μ^2)
            0 sin(2 * θ)*sqrt(ρ^2 - μ^2)/ρ^2 ν+sin(2 * θ)*μ/ρ^2 (cos(2 * θ)-ν^2)/ρ
            0 0 ρ -ν
        ]
    end

    @testset "Complicate matrix from Sandia technical report" begin
        H = Hevil2(
            0.111866322512629152,
            1.08867072154101741,
            0.338146383137297168,
            -0.313987810419091240,
        )

        @test Float64.(abs.(eigvals(big.(H)))) ≈ ones(4)
    end

    @testset "Issue 67" for (A, λs) in (
        (
            [
                1 -2 1 -1 -1 0
                0 1 0 1 0 1
                1 -1 2 0 -1 0
                0 1 0 2 1 1
                1 0 1 0 0 0
                0 -1 1 -1 -2 0
            ],
            [
                0.0,
                0.0,
                (3 - √big(3) * im) / 2,
                (3 + √big(3) * im) / 2,
                (3 - √big(3)im) / 2,
                (3 + √big(3)im) / 2,
            ],
        ),
        (
            [
                1 0 -1 0 0 0
                0 1 1 1 -1 0
                1 0 -1 0 0 0
                1 -1 0 -1 1 1
                0 0 1 0 0 0
                -1 0 1 0 0 0
            ],
            zeros(6),
        ),
        (
            [
                1 -2 -1 1 -1 0
                0 1 0 -1 0 1
                -1 1 2 0 1 0
                0 -1 -2 2 -1 -1
                1 0 -1 0 0 0
                0 -1 -1 1 0 0
            ],
            [
                (1 - √big(3) * im) / 2,
                (1 + √big(3) * im) / 2,
                (1 - √big(3)im) / 2,
                (1 + √big(3)im) / 2,
                2,
                2,
            ],
        ),
        (
            [
                2 0 -1 0 0 1
                0 2 0 -1 -1 0
                -1 0 1 0 0 -1
                0 -1 0 1 1 0
                0 1 0 -1 0 0
                -1 0 1 0 0 0
            ],
            ones(6),
        ),
        (
            [
                1 0 1 0 -1 0
                -2 1 2 -1 1 1
                -1 0 -1 0 1 0
                2 1 2 -1 -2 1
                1 0 1 0 -1 0
                1 -1 -2 1 0 -1
            ],
            [-1, -1, 0, 0, 0, 0],
        ),
    )

        @testset "shouldn't need excessive iterations (30*n) in the Float64 case" begin
            GenericLinearAlgebra._schur!(float(A))
        end

        # For BigFloats, many iterations are required for convergence
        # Improving this is probably a hard problem
        vals = eigvals(big.(A), maxiter = 1500)

        # It's hard to compare complex conjugate pairs so we compare the real and imaginary parts separately
        @test sort(real(vals)) ≈ sort(real(λs)) atol = 1e-25
        @test sort(imag(vals)) ≈ sort(imag(λs)) atol = 1e-25
    end

    @testset "_hessenberg! and Hessenberg" begin
        n = 10
        A = randn(n, n)
        HF = GenericLinearAlgebra._hessenberg!(copy(A))
        for i = 1:length(HF.τ)
            HM = convert(Matrix, HF.τ[i])
            A[(i+1):end, :] = HM * A[(i+1):end, :]
            A[:, (i+1):end] = A[:, (i+1):end] * HM'
        end
        @test tril(A, -2) ≈ zeros(n, n) atol = 1e-14

        @test eigvals(HF.H) ≈ eigvals(A)
        @test eigvals(HF.H) ≈ eigvals!(copy(HF))
        @test HF.H \ ones(n) ≈ Matrix(HF.H) \ ones(n)
    end
end

using Test

# @testset "The LinearAlgebra Test Suite" begin
include("juliaBLAS.jl")
include("cholesky.jl")
include("qr.jl")
include("eigenselfadjoint.jl")
include("eigengeneral.jl")
include("tridiag.jl")
include("svd.jl")
include("lapack.jl")
# end

using LinearAlgebra

import LinearAlgebra: mul!, rmul!

AdjointQtype = isdefined(LinearAlgebra, :AdjointQ) ? LinearAlgebra.AdjointQ : Adjoint

lmul!(G::LinearAlgebra.Givens, ::Nothing) = nothing
rmul!(::Nothing, G::LinearAlgebra.Givens) = nothing

function svdvals2x2(d1, d2, e)
    d1sq = d1 * d1
    d2sq = d2 * d2
    esq = e * e
    b = d1sq + d2sq + esq
    D = sqrt(abs2((d1 + d2) * (d1 - d2)) + esq * (2 * (d1sq + d2sq) + esq))
    D2 = b + D
    λ1 = 2 * d1sq * d2sq / D2
    λ2 = D2 / 2
    return minmax(sqrt(λ1), sqrt(λ2))
end

function svdIter!(
    B::Bidiagonal{T},
    n1,
    n2,
    shift,
    U = nothing,
    Vᴴ = nothing,
) where {T<:Real}

    if B.uplo === 'U'

        d = B.dv
        e = B.ev

        G, r = givens(d[n1] - abs2(shift) / d[n1], e[n1], n1, n1 + 1)
        lmul!(G, Vᴴ)

        ditmp = d[n1]
        ei1 = e[n1]
        di = ditmp * G.c + ei1 * G.s
        ei1 = -ditmp * G.s + ei1 * G.c
        di1 = d[n1+1]
        bulge = di1 * G.s
        di1 *= G.c

        for i = n1:n2-2
            G, r = givens(di, bulge, i, i + 1)
            rmul!(U, G')
            d[i] = G.c * di + G.s * bulge
            ei = G.c * ei1 + G.s * di1
            di1 = -G.s * ei1 + G.c * di1
            ei1 = e[i+1]
            bulge = G.s * ei1
            ei1 *= G.c

            G, r = givens(ei, bulge, i + 1, i + 2)
            lmul!(G, Vᴴ)
            e[i] = ei * G.c + bulge * G.s
            di = di1 * G.c + ei1 * G.s
            ei1 = -di1 * G.s + ei1 * G.c
            di2 = d[i+2]
            bulge = di2 * G.s
            di1 = di2 * G.c
        end

        G, r = givens(di, bulge, n2 - 1, n2)
        rmul!(U, G')
        d[n2-1] = G.c * di + G.s * bulge
        e[n2-1] = G.c * ei1 + G.s * di1
        d[n2] = -G.s * ei1 + G.c * di1

    else
        throw(ArgumentError("please convert to upper bidiagonal"))
    end

    return B
end

# See LAWN 3
function svdDemmelKahan!(
    B::Bidiagonal{T},
    n1,
    n2,
    U = nothing,
    Vᴴ = nothing,
) where {T<:Real}

    if B.uplo === 'U'

        d = B.dv
        e = B.ev

        oldcs = one(T)
        G = LinearAlgebra.Givens(1, 2, one(T), zero(T))
        Gold = G

        for i = n1:n2-1
            G, r = givens(d[i] * G.c, e[i], i, i + 1)
            lmul!(G, Vᴴ)
            if i != n1
                e[i-1] = Gold.s * r
            end

            Gold, d[i] = givens(Gold.c * r, d[i+1] * G.s, i, i + 1)
            rmul!(U, Gold')
        end

        h = d[n2] * G.c
        e[n2-1] = h * Gold.s
        d[n2] = h * Gold.c

    else
        throw(ArgumentError("please convert to upper bidiagonal"))
    end

    return B
end

# Recurrence to estimate smallest singular value from LAWN3 Lemma 1
function estimate_σ⁻!(
    dv::AbstractVector,
    ev::AbstractVector,
    n1::Integer,
    n2::Integer,
    tol::Real,
)

    # (4.3) p 18
    μ = abs(dv[n1])
    B1 = μ
    for j = n1:(n2-1)
        μ = abs(dv[j+1]) * (μ / (μ + abs(ev[j])))
        if abs(ev[j] / μ) < tol
            ev[j] = 0
        end
        B1 = min(B1, μ)
    end

    # (4.4) p 18
    λ = abs(dv[n2])
    B∞ = λ
    for j = (n2-1):-1:n1
        λ = abs(dv[j]) * (λ / (λ + abs(ev[j])))
        if abs(ev[j] / λ) < tol
            ev[j] = 0
        end
        B∞ = min(B∞, λ)
    end

    return min(B∞, B1)
end

# The actual SVD solver routine
# Notice that this routine doesn't adjust the sign and sorts the values
function __svd!(
    B::Bidiagonal{T},
    U = nothing,
    Vᴴ = nothing;
    tol = 100eps(T),
) where {T<:Real}

    n = size(B, 1)
    if n == 0
        # Exit early in the empty case
        return nothing
    end
    n1 = 1
    n2 = n
    d = B.dv
    e = B.ev
    iteration = 0

    thresh = tol * zero(first(d))

    if B.uplo === 'U'
        while true
            @label top

            # Search for biggest index for non-zero off diagonal value in e
            for n2i = n2:-1:1
                if n2i == 1
                    # We are done!
                    return nothing
                else
                    if abs(e[n2i-1]) > thresh
                        n2 = n2i
                        break
                    end
                end
            end

            # Search for largest sub-bidiagonal matrix ending at n2
            for _n1 = (n2-1):-1:1
                if _n1 == 1
                    n1 = _n1
                    break
                elseif abs(e[_n1-1]) < thresh
                    n1 = _n1
                    break
                end
            end
            # @debug "Active submatrix" iteration n1 n2 d[n1] d[n2] e[n1] e[n2 - 1]

            # Deflation check. See LAWN3 p21
            # The Demmel-Kahan iteration moves the zero to the end and produces a
            # zero super diagonal element as well
            for i = n1:n2
                if d[i] == 0
                    # @debug "Deflation! Exact zero in diagonal element" i
                    svdDemmelKahan!(B, n1, n2, U, Vᴴ)

                    # We have now moved a zero to the end so the problem is one smaller
                    n2 -= 1

                    # We'll start over to find the relevant submatrix after deflation
                    @goto top
                end
            end

            # See LAWN 3 p 18 and
            # We approximate the smallest and largest singular values of the
            # current block to determine if it's safe to use shift or if
            # the zero shift algorithm is required to maintain high relative
            # accuracy
            #
            # We also set a new threshhold to be used in the next iteration
            σ⁻ = estimate_σ⁻!(d, e, n1, n2, tol)
            σ⁺ = max(maximum(view(d, n1:n2)), maximum(view(e, n1:(n2-1))))
            fudge = n2 - n1 + 1
            thresh = tol * σ⁻

            # @debug "estimated quantities" σ⁻ σ⁺ fudge thresh

            if fudge * tol * σ⁻ <= eps(σ⁺)
                svdDemmelKahan!(B, n1, n2, U, Vᴴ)
            else
                shift = svdvals2x2(d[n2-1], d[n2], e[n2-1])[1]
                if shift^2 < eps(B.dv[n1]^2)
                    # Shift is too small to affect the iteration so just use
                    # zero-shift algorithm anyway
                    svdDemmelKahan!(B, n1, n2, U, Vᴴ)
                else
                    svdIter!(B, n1, n2, shift, U, Vᴴ)
                end
            end

            iteration += 1
        end
    else
        throw(ArgumentError("please convert to upper bidiagonal"))
    end
end

function _svdvals!(B::Bidiagonal{T}; tol = eps(T)) where {T<:Real}
    B = Bidiagonal(B.dv, B.ev, :U)
    __svd!(B, tol = tol)
    return sort(abs.(diag(B)), rev = true)
end

# We want to avoid that zero singular values zero out any singular vectors so we'd
# have to use a modified sign function
_sign(x) = ifelse(iszero(x), one(x), sign(x))

function _sort_and_adjust!(U, s, Vᴴ)
    n = length(s)

    # Adjust sign of singular values if necessary
    if any(!isposdef, s)
        rmul!(U, Diagonal(_sign.(s)))
        map!(abs, s, s)
    end

    # Sort singular values if necessary
    # FixMe! Try to do this without (much) allocation
    p = sortperm(s, by = abs, rev = true)
    if p != 1:n
        U[:] = U[:, p]
        s[:] = s[p]
        Vᴴ[:] = Vᴴ[p, :]
    end

    return nothing
end

# Convert a lower Bidiagonal to an upper by running a single pass
# of givens rotations from the left. A noop if the Bidiagnoal is
# already upper.
function _lower_to_upper!(B::Bidiagonal, U::Matrix)
    if B.uplo === 'U'
        return B
    end
    for i in 1:length(B.ev)
        G, r = givens(B.dv[i], B.ev[i], i, i + 1)
        B.dv[i] = r
        B.ev[i] = G.s * B.dv[i + 1]
        B.dv[i + 1] = G.c * B.dv[i + 1]
        rmul!(U, G')
    end
    return Bidiagonal(B.dv, B.ev, :U)
end

function _svd!(B::Bidiagonal{T}; tol = eps(T)) where {T<:Real}
    n = size(B, 1)

    U = Matrix{T}(I, n, n)
    Vᴴ = Matrix{T}(I, n, n)

    B = _lower_to_upper!(B, U)

    __svd!(B, U, Vᴴ, tol = tol)

    s = diag(B)

    # Sort and adjust the singular values. The algorithm used in __svd! might produce negative singular values and it will return the values in no particular ordering.
    _sort_and_adjust!(U, s, Vᴴ)

    return SVD(U, s, Vᴴ)
end

struct BidiagonalFactorization{T,S,U,V}
    bidiagonal::Bidiagonal{T,S}
    reflectors::U
    τl::V
    τr::V
end

function bidiagonalize!(A::AbstractMatrix)
    m, n = size(A)
    τl, τr = eltype(A)[], eltype(A)[]

    if m >= n
        # tall case: upper bidiagonal
        for i = 1:min(m, n)
            x = view(A, i:m, i)
            τi = LinearAlgebra.reflector!(x)
            push!(τl, τi)
            LinearAlgebra.reflectorApply!(x, τi, view(A, i:m, (i+1):n))
            if i < n
                x = view(A, i, i+1:n)
                conj!(x)
                τi = LinearAlgebra.reflector!(x)
                push!(τr, τi)
                LinearAlgebra.reflectorApply!(view(A, (i+1):m, (i+1):n), x, τi)
            end
        end

        bd = Bidiagonal(real(diag(A)), real(diag(A, 1)), :U)

        return BidiagonalFactorization{eltype(bd),typeof(bd.dv),typeof(A),typeof(τl)}(
            bd,
            A,
            τl,
            τr,
        )
    else
        # wide case: lower bidiagonal
        for i = 1:min(m, n)
            x = view(A, i, i:n)
            conj!(x)
            τi = LinearAlgebra.reflector!(x)
            push!(τr, τi)
            LinearAlgebra.reflectorApply!(view(A, (i+1):m, i:n), x, τi)
            if i < m
                x = view(A, i+1:m, i)
                τi = LinearAlgebra.reflector!(x)
                push!(τl, τi)
                LinearAlgebra.reflectorApply!(x, τi, view(A, (i+1):m, (i+1):n))
            end
        end

        bd = Bidiagonal(real(diag(A)), real(diag(A, -1)), :L)

        return BidiagonalFactorization{eltype(bd),typeof(bd.dv),typeof(A),typeof(τl)}(
            bd,
            A,
            τl,
            τr,
        )
    end
end

# This one is currently very type unstable but it is useful to be able to reuse
# existing elementary reflectors types such as QRPackedQ, LQPackedQ, and HessenbergQ
# such that multiplication methods are available for free.
function Base.getproperty(F::BidiagonalFactorization, s::Symbol)
    BD = getfield(F, :bidiagonal)
    R = getfield(F, :reflectors)
    τl = getfield(F, :τl)
    τr = getfield(F, :τr)
    if BD.uplo === 'U'
        if s === :leftQ
            return LinearAlgebra.QRPackedQ(R, τl)
        elseif s === :rightQ
            factors = copy(transpose(R[1:size(R, 2), :]))
            return LinearAlgebra.HessenbergQ{
                eltype(factors),
                typeof(factors),
                typeof(τr),
                false,
            }(
                'U',
                factors,
                τr,
            )
        else
            return getfield(F, s)
        end
    else
        if s === :leftQ
            factors = R[:, 1:size(R, 1)]
            return LinearAlgebra.HessenbergQ{
                eltype(factors),
                typeof(factors),
                typeof(τr),
                false,
            }(
                'U',
                factors,
                τl,
            )
        elseif s === :rightQ
            # FIXME! Can I get the LQPackedQ versino going to avoid the copy?
            # return transpose(LinearAlgebra.LQPackedQ(R, τr)) # FixMe! check that this shouldn't be adjoint
            LinearAlgebra.QRPackedQ(copy(transpose(R)), τr)
        else
            return getfield(F, s)
        end
    end
end

# For now, we define a generic lmul! and rmul! for HessenbergQ here
function lmul!(Q::LinearAlgebra.HessenbergQ, B::AbstractVecOrMat)

    m, n = size(B, 1), size(B, 2)

    if m != size(Q, 2)
        throw(DimensionMismatch(""))
    end

    for j = 1:n
        for l = length(Q.τ):-1:1
            τl = Q.τ[l]
            ṽ = view(Q.factors, (l+2):m, l)
            b = view(B, (l+2):m, j)
            vᴴb = B[l+1, j]
            if length(ṽ) > 0
                vᴴb += ṽ'b
            end
            B[l+1, j] -= τl * vᴴb
            b .-= ṽ .* τl .* vᴴb
        end
    end

    return B
end

function lmul!(adjQ::AdjointQtype{<:Any,<:LinearAlgebra.HessenbergQ}, B::AbstractVecOrMat)

    Q = parent(adjQ)
    m, n = size(B, 1), size(B, 2)

    if m != size(adjQ, 2)
        throw(DimensionMismatch(""))
    end

    for j = 1:n
        for l = 1:length(Q.τ)
            τl = Q.τ[l]
            ṽ = view(Q.factors, (l+2):m, l)
            b = view(B, (l+2):m, j)
            vᴴb = B[l+1, j]
            if length(ṽ) > 0
                vᴴb += ṽ'b
            end
            B[l+1, j] -= τl' * vᴴb
            b .-= ṽ .* τl' .* vᴴb
        end
    end

    return B
end

function rmul!(A::AbstractMatrix, Q::LinearAlgebra.HessenbergQ)

    m, n = size(A)

    if n != size(Q, 1)
        throw(DimensionMismatch(""))
    end

    for i = 1:m
        for l = 1:(n-1)
            τl = Q.τ[l]
            ṽ = view(Q.factors, (l+2):n, l)
            aᵀ = transpose(view(A, i, (l+2):n))
            aᵀv = A[i, l+1]
            if length(ṽ) > 0
                aᵀv += aᵀ * ṽ
            end
            A[i, l+1] -= aᵀv * τl
            aᵀ .-= aᵀv .* τl .* ṽ'
        end
    end

    return A
end

function rmul!(A::AbstractMatrix, adjQ::AdjointQtype{<:Any,<:LinearAlgebra.HessenbergQ})
    m, n = size(A)
    Q = parent(adjQ)

    if n != size(adjQ, 1)
        throw(DimensionMismatch(""))
    end

    for i = 1:m
        for l = (n-1):-1:1
            τl = Q.τ[l]
            ṽ = view(Q.factors, (l+2):n, l)
            aᵀ = transpose(view(A, i, (l+2):n))
            aᵀv = A[i, l+1]
            if length(ṽ) > 0
                aᵀv += aᵀ * ṽ
            end
            A[i, l+1] -= aᵀv * τl'
            aᵀ .-= aᵀv .* τl' .* ṽ'
        end
    end

    return A
end

# FIXME! Commented out for now because we currently don't produce
# any LQPackedQ matrices.
# function rmul!(A::AbstractMatrix, Q::LinearAlgebra.LQPackedQ)

#     m, n = size(A)

#     if n != size(Q, 1)
#         throw(DimensionMismatch(""))
#     end

#     for i = 1:m
#         for l = length(Q.τ):-1:1
#             τl = Q.τ[l]
#             ṽ = view(Q.factors, l, (l+1):n)
#             aᵀ = transpose(view(A, i, (l+1):n))
#             aᵀv = A[i, l]
#             if length(ṽ) > 0
#                 aᵀv += aᵀ * ṽ
#             end
#             A[i, l] -= aᵀv * τl
#             aᵀ .-= aᵀv .* τl .* ṽ'
#         end
#     end

#     return A
# end

# Overload LinearAlgebra methods

LinearAlgebra.svdvals!(B::Bidiagonal{T}; tol = eps(T)) where {T<:Real} =
    _svdvals!(B, tol = tol)

"""
    svdvals!(A [, tol])

Generic computation of singular values.
```jldoctest
julia> using LinearAlgebra, GenericLinearAlgebra, Quaternions

julia> n = 20;

julia> H = [big(1)/(i + j - 1) for i in 1:n, j in 1:n]; # The Hilbert matrix

julia> Float64(svdvals(H)[end]/svdvals(Float64.(H))[end] - 1) # The relative error of the LAPACK based solution in 64 bit floating point.
-0.9999999999447275

julia> A = qr([Quaternion(randn(4)...) for i in 1:3, j in 1:3]).Q *
           Diagonal([3, 2, 1]) *
           qr([Quaternion(randn(4)...) for i in 1:3, j in 1:3]).Q'; # A quaternion matrix with the singular value 1, 2, and 3.

julia> svdvals(A) ≈ [3, 2, 1]
true
```
"""
function LinearAlgebra.svdvals!(A::StridedMatrix; tol = eps(real(eltype(A))))
    B = bidiagonalize!(A).bidiagonal
    # It doesn't matter that we transpose the bidiagonal matrix when we are only interested in the values
    return svdvals!(Bidiagonal(B.dv, B.ev, :U), tol = tol)
end

# FixMe! The full keyword is redundant for Bidiagonal and should be removed from Base
LinearAlgebra.svd!(
    B::Bidiagonal{T};
    tol = eps(T),
    full = false,
    # To avoid breaking on <Julia 1.3, the `alg` keyword doesn't do anything. Once we drop support for Julia 1.2
    # and below, we can make the keyword argument work correctly
    alg = nothing,
) where {T<:Real} = _svd!(B, tol = tol)

"""
    svd!(A[, tol, full])::SVD

A generic singular value decomposition (SVD). The implementation only uses Julia functions so the SVD can be computed for any element type provided that the necessary arithmetic operations are supported by the element type.

- `tol`: The relative tolerance for determining convergence. The default value is `eltype(T)` where `T` is the element type of the input matrix bidiagonal (i.e. after converting the matrix to bidiagonal form).

- `full`: If set to `true` then all the left and right singular vectors are returned. If set to `false` then only the vectors corresponding to the number of rows and columns of the input matrix `A` are returned (the default).

# Algorithm
...tomorrow

# Example

```jldoctest
julia> svd(big.([1 2; 3 4]))
SVD{BigFloat, BigFloat, Matrix{BigFloat}}
U factor:
2×2 Matrix{BigFloat}:
 -0.404554   0.914514
 -0.914514  -0.404554
singular values:
2-element Vector{BigFloat}:
 5.464985704219042650451188493284182533042584640492784181017488774646871847029449
 0.3659661906262578204229643842614005434788136943931877734325179702209382149672422
Vt factor:
2×2 Matrix{BigFloat}:
 -0.576048  -0.817416
 -0.817416   0.576048
```
"""
function LinearAlgebra.svd!(
    A::StridedMatrix{T};
    tol = eps(real(eltype(A))),
    full = false,
    # To avoid breaking on <Julia 1.3, the `alg` keyword doesn't do anything. Once we drop support for Julia 1.2
    # and below, we can make the keyword argument work correctly
    alg = nothing,
    atol = 0,
    rtol = 0
) where {T}

    m, n = size(A)

    # Convert the input matrix A to bidiagonal form and return a BidiagonalFactorization object
    BF = bidiagonalize!(A)

    B = BF.bidiagonal

    # Compute the SVD of the bidiagonal matrix B
    F = _svd!(B, tol = tol)

    # Form the matrices U and Vᴴ by combining the singular vector matrices of the bidiagonal SVD with the Householder reflectors from the bidiagonal factorization.
    U = Matrix{T}(I, m, full ? m : min(m, n))
    U[1:min(m, n), 1:min(m, n)] = F.U
    lmul!(BF.leftQ, U)
    Vᴴ = Matrix{T}(I, full ? n : min(m, n), n)
    Vᴴ[1:min(m, n), 1:min(m, n)] = F.Vt
    rmul!(Vᴴ, BF.rightQ')

    s = F.S
    s[_count_svdvals(s, atol, rtol)+1:end] .= 0

    return SVD(U, s, Vᴴ)
end

function _count_svdvals(S, atol::Real, rtol::Real)
    isempty(S) && return 0
    tol = max(rtol * S[1], atol)
    return iszero(S[1]) ? 0 : searchsortedlast(S, tol, rev=true)
end

using Printf
using LinearAlgebra
using LinearAlgebra: givensAlgorithm

## EigenQ
struct EigenQ{T}
    uplo::Char
    factors::Matrix{T}
    τ::Vector{T}
end

Base.size(Q::EigenQ) = (size(Q.factors, 1), size(Q.factors, 1))
function Base.size(Q::EigenQ, i::Integer)
    if i < 1
        throw(ArgumentError(""))
    elseif i < 3
        return size(Q.factors, 1)
    else
        return 1
    end
end

function LinearAlgebra.lmul!(Q::EigenQ, B::StridedVecOrMat)
    m, n = size(B)
    if size(Q, 1) != m
        throw(DimensionMismatch("first dimension of second argument matrix doesn't match the size of the first argument reflectors"))
    end
    if Q.uplo == 'L'
        for k = length(Q.τ):-1:1
            h = view(Q.factors, (k + 1):m, k)
            τ = Q.τ[k]
            tmp = h[1]
            h[1] = 1
            for j = 1:n
                tmp = τ * (h' * view(B, (k + 1):m, j))
                for i = 1:(m - k)
                    B[k + i, j] -= h[i] * tmp
                end
            end
            h[1] = tmp
        end
    elseif Q.uplo == 'U'
        for k = length(Q.τ):-1:1
            h = view(Q.factors, 1:(m - k), m - k + 1)
            τ = Q.τ[k]
            tmp = h[end]
            h[end] = 1
            for j = 1:n
                tmp = τ * (h' * view(B, 1:(n - k), j))
                for i = 1:(n - k)
                    B[i, j] -= h[i] * tmp
                end
            end
            h[end] = tmp
        end
    else
        throw(ArgumentError("Q.uplo is neither 'L' or 'U'. This should never happen."))
    end
    return B
end

function LinearAlgebra.rmul!(A::StridedMatrix, Q::EigenQ)
    m, n = size(A)
    if size(Q, 1) != n
        throw(DimensionMismatch("second dimension of first argument matrix doesn't match the size of the second argument reflectors"))
    end
    if Q.uplo == 'L'
        for k = 1:length(Q.τ)
            h = view(Q.factors, (k + 1):n, k)
            τ = Q.τ[k]
            tmp = h[1]
            h[1] = 1
            for i = 1:m
                tmp = transpose(view(A, i, (k + 1):n)) * h * τ
                for j = 1:(n - k)
                    A[i, k + j] -= tmp * h[j]'
                end
            end
            h[1] = tmp
        end
    elseif Q.uplo == 'U'
        for k = 1:length(Q.τ)
            h = view(Q.factors, 1:(n - k), n - k + 1)
            τ = Q.τ[k]
            tmp = h[end]
            h[end] = 1
            for i = 1:m
                tmp = transpose(view(A, i, 1:(n - k))) * h * τ
                for j = 1:(n - k)
                    A[i, j] -= tmp * h[j]'
                end
            end
            h[end] = tmp
        end
    else
        throw(ArgumentError("Q.uplo is neither 'L' or 'U'. This should never happen."))
    end
    return A
end

Base.Array(Q::EigenQ{T}) where T = lmul!(Q, Matrix{T}(I, size(Q, 1), size(Q, 1)))


## SymmetricTridiagonalFactorization
struct SymmetricTridiagonalFactorization{T,Treal,S} <: Factorization{T}
    reflectors::EigenQ{T}
    diagonals::SymTridiagonal{Treal,S}
end

Base.size(S::SymmetricTridiagonalFactorization, i::Integer) = size(S.reflectors.factors, i)

function Base.getproperty(S::SymmetricTridiagonalFactorization, s::Symbol)
    if s == :Q
        return S.reflectors
    else
        return getfield(S, s)
    end
end

## Eigen solvers
function _updateVectors!(c, s, j, vectors)
    @inbounds for i = 1:size(vectors, 1)
        v1 = vectors[i, j+1]
        v2 = vectors[i, j]
        vectors[i, j+1] = c * v1 + s * v2
        vectors[i, j] = c * v2 - s * v1
    end
end


function eigvals2x2(d1::Number, d2::Number, e::Number)
    r1 = (d1 + d2) / 2
    r2 = hypot(d1 - d2, 2 * e) / 2
    return r1 + r2, r1 - r2
end
function eig2x2!(d::StridedVector, e::StridedVector, j::Integer, vectors::Matrix)
    dj = d[j]
    dj1 = d[j + 1]
    ej = e[j]
    r1 = (dj + dj1) / 2
    r2 = hypot(dj - dj1, 2 * ej) / 2
    λ⁺ = r1 + r2
    λ⁻ = r1 - r2
    d[j] = λ⁺
    d[j + 1] = λ⁻
    e[j] = 0
    if iszero(ej)
        c = one(λ⁺)
        s = zero(λ⁺)
    elseif abs(λ⁺ - dj) > abs(λ⁻ - dj)
        c = -ej / hypot(ej, λ⁺ - dj)
        s = sqrt(1 - c*c)
    else
        s = abs(ej) / hypot(ej, λ⁻ - dj)
        c = copysign(sqrt(1 - s*s), -ej)
    end

    _updateVectors!(c, s, j, vectors)

    return c, s
end

function eigvalsPWK!(S::SymTridiagonal{T}; tol = eps(T)) where {T<:Real}
    d = S.dv
    e = S.ev
    n = length(d)
    blockstart = 1
    blockend = n
    iter = 0
    @inbounds begin
        for i = 1:n-1
            e[i] = abs2(e[i])
        end
        while true
            # Check for zero off diagonal elements
            for be = (blockstart + 1):n
                if abs(e[be - 1]) <= tol * sqrt(abs(d[be - 1])) * sqrt(abs(d[be]))
                    blockend = be - 1
                    break
                end
                blockend = n
            end

            # @debug "submatrix" blockstart blockend

            # Deflate?
            if blockstart == blockend
                # @debug "Deflate? Yes!"
                blockstart += 1
            elseif blockstart + 1 == blockend
                # @debug "Defalte? Yes, but after solving 2x2 block!"
                d[blockstart], d[blockend] =
                    eigvals2x2(d[blockstart], d[blockend], sqrt(e[blockstart]))
                e[blockstart] = zero(T)
                blockstart += 1
            else
                # @debug "Deflate? No!"
                # Calculate shift
                sqrte = sqrt(e[blockstart])
                μ = (d[blockstart+1] - d[blockstart]) / (2 * sqrte)
                r = hypot(μ, one(T))
                μ = d[blockstart] - sqrte / (μ + copysign(r, μ))

                # QL bulk chase
                # @debug "Values before PWK QL bulge chase" e[blockstart] e[blockend-1] μ
                singleShiftQLPWK!(S, μ, blockstart, blockend)

                rotations = blockend - blockstart
                iter += rotations
                # @debug "Values after PWK QL bulge chase" e[blockstart] e[blockend-1] rotations
            end
            if blockstart >= n
                break
            end
        end
    end

    return d
end

function eigQL!(
    S::SymTridiagonal{T};
    vectors::Matrix = zeros(T, 0, size(S, 1)),
    tol = eps(T),
) where {T<:Real}
    d = S.dv
    e = S.ev
    n = length(d)

    if size(vectors, 2) != n
        throw(
            DimensionMismatch(
                "eigenvector matrix must have $(n) columns but had $(size(vectors, 2))",
            ),
        )
    end
    if size(vectors, 1) > n
        throw(
            DimensionMismatch(
                "eigenvector matrix must have at most $(n) rows but had $(size(vectors, 1))",
            ),
        )
    end

    blockstart = 1
    blockend = n
    @inbounds begin
        while true
            # Check for zero off diagonal elements
            for be = (blockstart + 1):n
                if abs(e[be - 1]) <= tol * sqrt(abs(d[be - 1])) * sqrt(abs(d[be]))
                    blockend = be - 1
                    break
                end
                blockend = n
            end

            # @debug "submatrix" blockstart blockend

            # Deflate?
            if blockstart == blockend
                # @debug "Deflate? Yes!"
                blockstart += 1
            elseif blockstart + 1 == blockend
                # @debug "Deflate? Yes, but after solving 2x2 block"
                eig2x2!(d, e, blockstart, vectors)
                blockstart += 2
            else
                # @debug "Deflate? No!"
                # Calculate shift
                μ = (d[blockstart + 1] - d[blockstart]) / (2 * e[blockstart])
                r = hypot(μ, one(T))
                μ = d[blockstart] - (e[blockstart] / (μ + copysign(r, μ)))

                # QL bulk chase
                # @debug "Values before bulge chase" e[blockstart] e[blockend - 1] d[blockstart] μ
                singleShiftQL!(S, μ, blockstart, blockend, vectors)
                # @debug "Values after bulge chase" e[blockstart] e[blockend - 1] d[blockstart]
            end

            if blockstart >= n
                break
            end
        end
    end

    return d, vectors
end

function eigQR!(
    S::SymTridiagonal{T};
    vectors::Matrix = zeros(T, 0, size(S, 1)),
    tol = eps(T),
) where {T<:Real}
    d = S.dv
    e = S.ev
    n = length(d)
    blockstart = 1
    blockend = n
    @inbounds begin
        while true
            # Check for zero off diagonal elements
            for be = (blockstart + 1):n
                if abs(e[be - 1]) <= tol * sqrt(abs(d[be - 1])) * sqrt(abs(d[be]))
                    blockend = be - 1
                    break
                end
                blockend = n
            end

            # @debug "submatrix" blockstart blockend

            # Deflate?
            if blockstart == blockend
                # @debug "Deflate? Yes!"
                blockstart += 1
            elseif blockstart + 1 == blockend
                # @debug "Deflate? Yes, but after solving 2x2 block!"
                eig2x2!(d, e, blockstart, vectors)
                blockstart += 2
            else
                # @debug "Deflate? No!"
                # Calculate shift
                μ = (d[blockend - 1] - d[blockend]) / (2 * e[blockend - 1])
                r = hypot(μ, one(T))
                μ = d[blockend] - (e[blockend - 1] / (μ + copysign(r, μ)))

                # QR bulk chase
                # @debug "Values before QR bulge chase" e[blockstart] e[blockend - 1] d[blockend] μ
                singleShiftQR!(S, μ, blockstart, blockend, vectors)
                # @debug "Values after QR bulge chase" e[blockstart] e[blockend - 1] d[blockend]
            end
            if blockstart >= n
                break
            end
        end
    end

    return d, vectors
end

# Own implementation based on Parlett's book
function singleShiftQLPWK!(
    S::SymTridiagonal,
    shift::Number,
    istart::Integer = 1,
    iend::Integer = length(S.dv),
)
    d = S.dv
    e = S.ev
    n = length(d)
    γi = d[iend] - shift
    π = abs2(γi)
    ci = one(eltype(S))
    s = zero(eltype(S))
    @inbounds for i = iend-1:-1:istart
        ei = e[i]
        ζ = π + ei
        if i < iend - 1
            e[i+1] = s * ζ
        end
        ci1 = ci
        ci = π / ζ
        s = ei / ζ
        di = d[i]
        γi1 = γi
        γi = ci * (di - shift) - s * γi1
        d[i+1] = γi1 + di - γi
        π = ci == 0 ? ei * ci1 : γi * γi / ci
    end
    e[istart] = s * π
    d[istart] = shift + γi
    S
end

# Own implementation based on Parlett's book
function singleShiftQL!(
    S::SymTridiagonal,
    shift::Number,
    istart::Integer = 1,
    iend::Integer = length(S.dv),
    vectors = zeros(eltype(S), 0, size(S, 1)),
)
    d, e = S.dv, S.ev
    n = length(d)
    γi = d[iend] - shift
    π = γi
    ci, si = one(eltype(S)), zero(eltype(S))
    @inbounds for i = (iend-1):-1:istart
        ei = e[i]
        ci1 = ci
        si1 = si
        ci, si, ζ = givensAlgorithm(π, ei)
        if i < iend - 1
            e[i+1] = si1 * ζ
        end
        di = d[i]
        γi1 = γi
        γi = ci * ci * (di - shift) - si * si * γi1
        d[i+1] = γi1 + di - γi
        π = ci == 0 ? -ei * ci1 : γi / ci

        # update eigen vectors
        _updateVectors!(ci, si, i, vectors)
    end
    e[istart] = si * π
    d[istart] = shift + γi
    S
end

# Own implementation based on Parlett's book
function singleShiftQR!(
    S::SymTridiagonal,
    shift::Number,
    istart::Integer = 1,
    iend::Integer = length(S.dv),
    vectors = zeros(eltype(S), 0, size(S, 1)),
)
    d, e = S.dv, S.ev
    n = length(d)
    γi = d[istart] - shift
    π = γi
    ci, si = one(eltype(S)), zero(eltype(S))
    for i = (istart+1):iend
        ei = e[i-1]
        ci1 = ci
        si1 = si
        ci, si, ζ = givensAlgorithm(π, ei)
        if i > istart + 1
            e[i-2] = si1 * ζ
        end
        di = d[i]
        γi1 = γi
        γi = ci * ci * (di - shift) - si * si * γi1
        d[i-1] = γi1 + di - γi
        π = ci == 0 ? -ei * ci1 : γi / ci

        # update eigen vectors
        _updateVectors!(ci, -si, i - 1, vectors)
    end
    e[iend-1] = si * π
    d[iend] = shift + γi
    S
end

symtri!(A::Hermitian) = A.uplo == 'L' ? symtriLower!(A.data) : symtriUpper!(A.data)
symtri!(A::Symmetric{<:Real}) = A.uplo == 'L' ? symtriLower!(A.data) : symtriUpper!(A.data)

# Assume that lower triangle stores the relevant part
function symtriLower!(
    AS::StridedMatrix{T},
    τ = zeros(T, size(AS, 1) - 1),
    u = Vector{T}(undef, size(AS, 1)),
) where {T}
    n = size(AS, 1)

    # We ignore any non-real components of the diagonal
    @inbounds for i = 1:n
        AS[i, i] = real(AS[i, i])
    end

    @inbounds for k = 1:(n-2+!(T <: Real))

        x = view(AS, (k + 1):n, k)

        τk = LinearAlgebra.reflector!(x)
        τ[k] = τk

        # Temporarily store the implicit 1
        tmp = x[1]
        x[1] = 1

        Ã = view(AS, (k + 1):n, (k + 1):n)
        ũ = view(u, (k + 1):n)

        # Form Ãvτ
        mul!(ũ, Hermitian(Ã, :L), x, τk, zero(τk))

        # Form τx'Ãvτ (which is real except for rounding)
        ξ = real(τk'*(x'*ũ))

        # Compute the rank up and down grade
        # Ã = Ã + τx'Ãvτ - τx'Ã - Ãvτ
        for j in 1:(n - k)
            xⱼ = x[j]
            ũⱼ = ũ[j]
            ξxⱼ = ξ * xⱼ
            for i in j:(n - k)
                AS[k + i, k + j] += x[i] * ξxⱼ' - x[i] * ũⱼ' - ũ[i] * xⱼ'
            end
        end

        # Restore element
        x[1] = tmp
    end
    SymmetricTridiagonalFactorization(
        EigenQ(
            'L',
            AS,
            τ,
        ),
        SymTridiagonal(real(diag(AS)), real(diag(AS, -1))),
    )
end

# Assume that upper triangle stores the relevant part
function symtriUpper!(
    AS::StridedMatrix{T},
    τ = zeros(T, size(AS, 1) - 1),
    u = Vector{T}(undef, size(AS, 1)),
) where {T}
    n = LinearAlgebra.checksquare(AS)

    # We ignore any non-real components of the diagonal
    @inbounds for i = 1:n
        AS[i, i] = real(AS[i, i])
    end

    @inbounds for k = 1:(n-2+!(T <: Real))
        # LAPACK allows the reflection element to be chosen freely whereas
        # LinearAlgebra's reflector! assumes it is the first element in the vector
        # Maybe we should implement a method similar to the LAPACK version
        x = view(AS, 1:(n - k), n - k + 1)
        xᵣ = view(AS, (n - k):-1:1, n - k + 1)

        τk = LinearAlgebra.reflector!(xᵣ)
        τ[k] = τk

        # Temporarily store the implicit 1
        tmp = x[end]
        x[end] = 1

        Ã = view(AS, 1:(n - k), 1:(n - k))
        ũ = view(u, 1:(n - k))

        # Form Ãvτ
        mul!(ũ, Hermitian(Ã, :U), x, τk, zero(τk))

        # Form τx'Ãvτ (which is real except for rounding)
        ξ = real(τk'*(x'*ũ))

        # Compute the rank up and down grade
        # Ã = Ã + τx'Ãvτ - τx'Ã - Ãvτ
        for j in 1:(n - k)
            xⱼ = x[j]
            ũⱼ = ũ[j]
            ξxⱼ = ξ * xⱼ
            for i in 1:j
                AS[i, j] += x[i] * ξxⱼ' - x[i] * ũⱼ' - ũ[i] * xⱼ'
            end
        end

        # Restore element
        x[end] = tmp
    end
    SymmetricTridiagonalFactorization(
        EigenQ(
            'U',
            AS,
            τ,
        ),
        SymTridiagonal(real(diag(AS)), real(diag(AS, 1))),
    )
end

_eigvals!(A::SymTridiagonal; tol = eps(real(eltype(A))), sortby::Union{Function,Nothing}=LinearAlgebra.eigsortby) =
    LinearAlgebra.sorteig!(eigvalsPWK!(A; tol), sortby == nothing ? LinearAlgebra.eigsortby : sortby)

_eigvals!(A::SymmetricTridiagonalFactorization; tol = eps(real(eltype(A))), sortby::Union{Function,Nothing}=LinearAlgebra.eigsortby) =
    _eigvals!(A.diagonals; tol, sortby)

_eigvals!(A::Hermitian; tol = eps(real(eltype(A))), sortby::Union{Function,Nothing}=LinearAlgebra.eigsortby) =
    _eigvals!(symtri!(A); tol, sortby)

_eigvals!(A::Symmetric{<:Real}; tol = eps(eltype(A)), sortby::Union{Function,Nothing}=LinearAlgebra.eigsortby) =
    _eigvals!(symtri!(A); tol, sortby)

LinearAlgebra.eigvals!(A::SymmetricTridiagonalFactorization; tol = eps(real(eltype(A))), sortby::Union{Function,Nothing}=LinearAlgebra.eigsortby) =
    _eigvals!(A; tol, sortby)

LinearAlgebra.eigvals!(A::SymTridiagonal; tol = eps(real(eltype(A))), sortby::Union{Function,Nothing}=LinearAlgebra.eigsortby) =
    _eigvals!(A; tol, sortby)

LinearAlgebra.eigvals!(A::Hermitian; tol = eps(real(eltype(A))), sortby::Union{Function,Nothing}=LinearAlgebra.eigsortby, alg = nothing) =
    _eigvals!(A; tol, sortby)

LinearAlgebra.eigvals!(A::Symmetric{<:Real}; tol = eps(eltype(A)), sortby::Union{Function,Nothing}=LinearAlgebra.eigsortby, alg = nothing) =
    _eigvals!(A; tol, sortby)

_eigen!(A::SymmetricTridiagonalFactorization; tol = eps(real(eltype(A))), sortby::Union{Function,Nothing}=LinearAlgebra.eigsortby) =
    LinearAlgebra.Eigen(
        LinearAlgebra.sorteig!(
            eigQL!(
                A.diagonals;
                vectors = Array(A.Q),
                tol
            )...,
            sortby == nothing ? LinearAlgebra.eigsortby : sortby
        )...
    )

_eigen!(A::SymTridiagonal; tol = eps(real(eltype(A))), sortby::Union{Function,Nothing}=LinearAlgebra.eigsortby) =
    LinearAlgebra.Eigen(
        LinearAlgebra.sorteig!(
            eigQL!(
                A;
                vectors = Matrix{eltype(A)}(I, size(A, 1), size(A, 1)),
                tol
            )...,
            sortby == nothing ? LinearAlgebra.eigsortby : sortby
        )...
    )

_eigen!(A::Hermitian; tol = eps(real(eltype(A))), sortby::Union{Function,Nothing}=LinearAlgebra.eigsortby) =
    _eigen!(symtri!(A); tol, sortby)

_eigen!(A::Symmetric{<:Real}; tol = eps(eltype(A)), sortby::Union{Function,Nothing}=LinearAlgebra.eigsortby) =
    _eigen!(symtri!(A); tol, sortby)

LinearAlgebra.eigen!(A::SymmetricTridiagonalFactorization; tol = eps(real(eltype(A))), sortby::Union{Function,Nothing}=LinearAlgebra.eigsortby) =
    _eigen!(A; tol, sortby)

LinearAlgebra.eigen!(A::SymTridiagonal; tol = eps(real(eltype(A))), sortby::Union{Function,Nothing}=LinearAlgebra.eigsortby) =
    _eigen!(A; tol, sortby)

LinearAlgebra.eigen!(A::Hermitian; tol = eps(real(eltype(A))), sortby::Union{Function,Nothing}=LinearAlgebra.eigsortby, alg = nothing) =
    _eigen!(A; tol, sortby)

LinearAlgebra.eigen!(A::Symmetric{<:Real}; tol = eps(eltype(A)), sortby::Union{Function,Nothing}=LinearAlgebra.eigsortby, alg = nothing) =
    _eigen!(A; tol, sortby)


function eigen2!(
    A::SymmetricTridiagonalFactorization;
    tol = eps(real(float(one(eltype(A))))),
)
    V = zeros(eltype(A), 2, size(A, 1))
    V[1] = 1
    V[end] = 1
    LinearAlgebra.sorteig!(
        eigQL!(A.diagonals; vectors = rmul!(V, A.Q), tol)...,
        LinearAlgebra.eigsortby
    )
end

function eigen2!(A::SymTridiagonal; tol = eps(real(float(one(eltype(A))))))
    V = zeros(eltype(A), 2, size(A, 1))
    V[1] = 1
    V[end] = 1
    LinearAlgebra.sorteig!(
        eigQL!(A; vectors = V, tol)...,
        LinearAlgebra.eigsortby
    )
end

eigen2!(A::Hermitian; tol = eps(float(real(one(eltype(A)))))) =
    eigen2!(symtri!(A); tol)

eigen2!(A::Symmetric{<:Real}; tol = eps(float(one(eltype(A))))) =
    eigen2!(symtri!(A); tol)


eigen2(A::SymTridiagonal; tol = eps(float(real(one(eltype(A)))))) =
    eigen2!(copy(A); tol)

eigen2(A::Hermitian; tol = eps(float(real(one(eltype(A)))))) = eigen2!(copy(A); tol)

eigen2(A::Symmetric{<:Real}; tol = eps(float(one(eltype(A))))) = eigen2!(copy(A); tol)

# First method of each type here is identical to the method defined in
# LinearAlgebra but is needed for disambiguation
const _eigencopy_oftype = if VERSION >= v"1.9"
    LinearAlgebra.eigencopy_oftype
else
    LinearAlgebra.copy_oftype
end

if VERSION < v"1.7"
    function LinearAlgebra.eigvals(A::Hermitian{<:Real})
        T = typeof(sqrt(zero(eltype(A))))
        return eigvals!(_eigencopy_oftype(A, T))
    end
    function LinearAlgebra.eigvals(A::Hermitian{<:Complex})
        T = typeof(sqrt(zero(eltype(A))))
        return eigvals!(_eigencopy_oftype(A, T))
    end
    function LinearAlgebra.eigvals(A::Hermitian)
        T = typeof(sqrt(zero(eltype(A))))
        return eigvals!(_eigencopy_oftype(A, T))
    end
    function LinearAlgebra.eigen(A::Hermitian{<:Real})
        T = typeof(sqrt(zero(eltype(A))))
        return eigen!(_eigencopy_oftype(A, T))
    end
    function LinearAlgebra.eigen(A::Hermitian{<:Complex})
        T = typeof(sqrt(zero(eltype(A))))
        return eigen!(_eigencopy_oftype(A, T))
    end
    function LinearAlgebra.eigen(A::Hermitian)
        T = typeof(sqrt(zero(eltype(A))))
        return eigen!(_eigencopy_oftype(A, T))
    end
end

# Aux (should go somewhere else at some point)
function LinearAlgebra.givensAlgorithm(f::Real, g::Real)
    h = hypot(f, g)
    return f / h, g / h, h
end

using Test, GenericLinearAlgebra, LinearAlgebra

@testset "rankUpdate!" begin
    A, B, x = (Hermitian(randn(5, 5)), randn(5, 2), randn(5))
    Ac, Bc, xc = (
        Hermitian(complex.(randn(5, 5), randn(5, 5))),
        complex.(randn(5, 2), randn(5, 2)),
        complex.(randn(5), randn(5)),
    )
    @test rankUpdate!(copy(A), x) ≈ A .+ x .* x'
    @test rankUpdate!(copy(Ac), xc) ≈ Ac .+ xc .* xc'

    @test rankUpdate!(copy(A), B, 0.5, 0.5) ≈ 0.5 * A + 0.5 * B * B'
    @test rankUpdate!(copy(Ac), Bc, 0.5, 0.5) ≈ 0.5 * Ac + 0.5 * Bc * Bc'

    @test invoke(rankUpdate!, Tuple{Hermitian,StridedVecOrMat,Real}, copy(Ac), Bc, 1.0) ≈
          rankUpdate!(copy(Ac), Bc, 1.0, 1.0)
end

@testset "triangular multiplication: $(typeof(T))" for T ∈ (
    UpperTriangular(complex.(randn(5, 5), randn(5, 5))),
    UnitUpperTriangular(complex.(randn(5, 5), randn(5, 5))),
    LowerTriangular(complex.(randn(5, 5), randn(5, 5))),
    UnitLowerTriangular(complex.(randn(5, 5), randn(5, 5))),
)
    B = complex.(randn(5, 5), randn(5, 5))
    @test lmul!(T, copy(B), complex(0.5, 0.5)) ≈ T * B * complex(0.5, 0.5)
    @test lmul!(T', copy(B), complex(0.5, 0.5)) ≈ T' * B * complex(0.5, 0.5)
end

module GenericLinearAlgebra

import LinearAlgebra: mul!, ldiv!

include("juliaBLAS.jl")
include("lapack.jl")
include("cholesky.jl")
include("householder.jl")
include("qr.jl")
include("eigenSelfAdjoint.jl")
include("eigenGeneral.jl")
include("tridiag.jl")
include("svd.jl")
end

using Documenter
using GenericLinearAlgebra

DocMeta.setdocmeta!(GenericLinearAlgebra, :DocTestSetup, :(using GenericLinearAlgebra, LinearAlgebra); recursive=true)

makedocs(
    sitename = "GenericLinearAlgebra",
    format = Documenter.HTML(),
    modules = [GenericLinearAlgebra]
)

# Documenter can also automatically deploy documentation to gh-pages.
# See "Hosting Documentation" and deploydocs() in the Documenter manual
# for more information.
deploydocs(
    repo = "github.com/JuliaLinearAlgebra/GenericLinearAlgebra.jl.git"
)

import Base: *, eltype, size
import LinearAlgebra: adjoint, mul!, rmul!

struct Householder{T,S<:StridedVector}
    v::S
    τ::T
end
struct HouseholderBlock{T,S<:StridedMatrix,U<:StridedMatrix}
    V::S
    T::UpperTriangular{T,U}
end

size(H::Householder) = (length(H.v) + 1, length(H.v) + 1)
size(H::Householder, i::Integer) = i <= 2 ? length(H.v) + 1 : 1

eltype(H::Householder{T}) where {T} = T
eltype(H::HouseholderBlock{T}) where {T} = T

adjoint(H::Householder{T}) where {T} = Adjoint{T,typeof(H)}(H)
adjoint(H::HouseholderBlock{T}) where {T} = Adjoint{T,typeof(H)}(H)

function lmul!(H::Householder, A::StridedMatrix)
    m, n = size(A)
    length(H.v) == m - 1 || throw(
        DimensionMismatch(
            "size of reflector is $(length(H.v) + 1) but first dimension of matrix is $(size(A, 1))",
        ),
    )
    v = view(H.v, 1:m-1)
    τ = H.τ
    for j = 1:n
        va = A[1, j]
        Aj = view(A, 2:m, j)
        va += dot(v, Aj)
        va = τ * va
        A[1, j] -= va
        axpy!(-va, v, Aj)
    end
    A
end

function rmul!(A::StridedMatrix, H::Householder)
    m, n = size(A)
    length(H.v) == n - 1 || throw(
        DimensionMismatch(
            "size of reflector is $(length(H.v) + 1) but second dimension of matrix is $(size(A, 2))",
        ),
    )
    v = view(H.v, :)
    τ = H.τ
    a1 = view(A, :, 1)
    A1 = view(A, :, 2:n)
    x = A1 * v
    axpy!(one(τ), a1, x)
    axpy!(-τ, x, a1)
    rankUpdate!(A1, x, v, -τ)
    A
end

function lmul!(adjH::Adjoint{<:Any,<:Householder}, A::StridedMatrix)
    H = parent(adjH)
    m, n = size(A)
    length(H.v) == m - 1 || throw(
        DimensionMismatch(
            "size of reflector is $(length(H.v) + 1) but first dimension of matrix is $(size(A, 1))",
        ),
    )
    v = view(H.v, 1:m-1)
    τ = H.τ
    for j = 1:n
        va = A[1, j]
        Aj = view(A, 2:m, j)
        va += dot(v, Aj)
        va = τ'va
        A[1, j] -= va
        axpy!(-va, v, Aj)
    end
    A
end

# FixMe! This is a weird multiplication method and at least its behavior needs to be explained
function lmul!(H::HouseholderBlock{T}, A::StridedMatrix{T}, M::StridedMatrix{T}) where {T}
    V = H.V
    mA, nA = size(A)
    nH = size(V, 1)
    blocksize = min(nH, size(V, 2))
    nH == mA || throw(DimensionMismatch(""))

    # Reflector block is split into a UnitLowerTriangular top part and rectangular lower part
    V1 = LinearAlgebra.UnitLowerTriangular(view(V, 1:blocksize, 1:blocksize))
    V2 = view(V, blocksize+1:mA, 1:blocksize)

    # Split A to match the split in the reflector block
    A1 = view(A, 1:blocksize, 1:nA)
    A2 = view(A, blocksize+1:mA, 1:nA)

    # Copy top part of A (A1) to temporary work space
    copyto!(M, A1)
    # Multiply UnitLowerTriangular V1 and A1 in-place in M (M = V1'A1)
    lmul!(V1', M)
    # Add V2'A2 to V1'A1 (M := M + V2'A2)
    mul!(M, V2', A2, one(T), one(T))
    # Multiply the elementary block loading T (UpperTriangular) and M in-place
    lmul!(H.T, M)

    # A2 := A2 - V2*M
    mul!(A2, V2, M, -one(T), one(T))
    # A1 := A1 - V1*M but since V1 is UnitLowerTriangular we do it in two steps:
    ## 1. M  := -V1*M
    ## 2. A1 := A1 + M
    lmul!(V1, M, -one(T))
    axpy!(one(T), M, A1)

    return A
end
(*)(H::HouseholderBlock{T}, A::StridedMatrix{T}) where {T} =
    lmul!(H, copy(A), similar(A, (min(size(H.V)...), size(A, 2))))

function lmul!(
    adjH::Adjoint{T,<:HouseholderBlock{T}},
    A::StridedMatrix{T},
    M::StridedMatrix,
) where {T}
    H = parent(adjH)
    V = H.V
    mA, nA = size(A)
    nH = size(V, 1)
    blocksize = min(nH, size(V, 2))
    nH == mA || throw(DimensionMismatch(""))

    # Reflector block is split into a UnitLowerTriangular top part and rectangular lower part
    V1 = LinearAlgebra.UnitLowerTriangular(view(V, 1:blocksize, 1:blocksize))
    V2 = view(V, blocksize+1:mA, 1:blocksize)

    # Split A to match the split in the reflector block
    A1 = view(A, 1:blocksize, 1:nA)
    A2 = view(A, blocksize+1:mA, 1:nA)

    # Copy top part of A (A1) to temporary work space
    copyto!(M, A1)
    # Multiply UnitLowerTriangular V1 and A1 in-place in M (M = V1'A1)
    lmul!(V1', M)
    # Add V2'A2 to V1'A1 (M := M + V2'A2)
    mul!(M, V2', A2, one(T), one(T))
    # Multiply the elementary block loading T (UpperTriangular) and M in-place
    lmul!(H.T', M)

    # A2 := A2 - V2*M
    mul!(A2, V2, M, -one(T), one(T))
    # A1 := A1 - V1*M but since V1 is UnitLowerTriangular we do it in two steps:
    ## 1. M  := -V1*M
    ## 2. A1 := A1 + M
    lmul!(V1, M, -one(T))
    axpy!(one(T), M, A1)

    return A
end
(*)(adjH::Adjoint{T,<:HouseholderBlock{T}}, A::StridedMatrix{T}) where {T} =
    lmul!(adjH, copy(A), similar(A, (min(size(parent(adjH).V)...), size(A, 2))))

Base.convert(::Type{Matrix}, H::Householder{T}) where {T} = convert(Matrix{T}, H)
Base.convert(::Type{Matrix{T}}, H::Householder) where {T} =
    lmul!(H, Matrix{T}(I, size(H, 1), size(H, 1)))

using LinearAlgebra

import Base: getindex, size
import LinearAlgebra: reflectorApply!

struct QR2{T,S<:AbstractMatrix{T},V<:AbstractVector{T}} <: Factorization{T}
    factors::S
    τ::V
    QR2{T,S,V}(
        factors::AbstractMatrix{T},
        τ::AbstractVector{T},
    ) where {T,S<:AbstractMatrix,V<:AbstractVector} = new(factors, τ)
end
QR2(factors::AbstractMatrix{T}, τ::Vector{T}) where {T} = QR2{T,typeof(factors)}(factors, τ)

size(F::QR2, i::Integer...) = size(F.factors, i...)

# Similar to the definition in base but applies the reflector from the right
@inline function reflectorApply!(A::StridedMatrix, x::AbstractVector, τ::Number) # apply conjugate transpose reflector from right.
    m, n = size(A)
    if length(x) != n
        throw(
            DimensionMismatch(
                "reflector must have same length as second dimension of matrix",
            ),
        )
    end
    @inbounds begin
        for i = 1:m
            Aiv = A[i, 1]
            for j = 2:n
                Aiv += A[i, j] * x[j]
            end
            Aiv = Aiv * τ
            A[i, 1] -= Aiv
            for j = 2:n
                A[i, j] -= Aiv * x[j]'
            end
        end
    end
    return A
end

# FixMe! Consider how to represent Q

# immutable Q{T,S<:QR2} <: AbstractMatrix{T}
#     data::S
# end

# size(A::Q) = size(A.data)
# size(A::Q, i::Integer) = size(A.data, i)

# getindex{T}(A::QR2{T}, ::Type{Tuple{:Q}}) = Q{T,typeof(A)}(A)

function getindex(A::QR2{T}, ::Type{Tuple{:R}}) where {T}
    m, n = size(A)
    if m >= n
        UpperTriangular(view(A.factors, 1:n, 1:n))
    else
        throw(ArgumentError("R matrix is trapezoid and cannot be extracted with indexing"))
    end
end

function getindex(A::QR2{T}, ::Type{Tuple{:QBlocked}}) where {T}
    m, n = size(A)
    mmn = min(m, n)
    F = A.factors
    τ = A.τ
    Tmat = zeros(T, mmn, mmn)
    for j = 1:mmn
        for i = 1:j-1
            Tmat[i, j] = τ[i] * (F[j, i] + dot(view(F, j+1:m, i), view(F, j+1:m, j)))
        end
    end
    LinearAlgebra.inv!(LinearAlgebra.UnitUpperTriangular(Tmat))
    for j = 1:min(m, n)
        Tmat[j, j] = τ[j]
        for i = 1:j-1
            Tmat[i, j] = Tmat[i, j] * τ[j]
        end
    end
    HouseholderBlock{T,typeof(F),Matrix{T}}(F, UpperTriangular(Tmat))
end

# qrUnblocked!(A::StridedMatrix) = LinearAlgebra.qrfactUnblocked!(A)
function qrUnblocked!(
    A::StridedMatrix{T},
    τ::StridedVector{T} = fill(zero(T), min(size(A)...)),
) where {T}

    m, n = size(A)

    # Make a vector view of the first column
    a = view(A, :, 1)
    # Construct the elementary reflector of the first column in-place
    τ1 = LinearAlgebra.reflector!(a)
    # Store reflector loading in τ
    τ[1] = τ1

    # Apply the reflector to the trailing columns if any
    if n > 1
        reflectorApply!(a, τ1, view(A, :, 2:n))
    end

    # Call the function recursively on the submatrix excluding first row and column or return
    if m > 1 && n > 1
        qrUnblocked!(view(A, 2:m, 2:n), view(τ, 2:min(m, n)))
    end

    return QR2{T,typeof(A),typeof(τ)}(A, τ)
end

function qrBlocked!(
    A::StridedMatrix{T},
    blocksize::Integer = 12,
    τ::StridedVector{T} = fill(zero(T), min(size(A)...)),
    work = Matrix{T}(undef, blocksize, size(A, 2)),
) where {T}

    m, n = size(A)

    # Make a vector view of the first column block
    A1 = view(A, :, 1:min(n, blocksize))
    # Construct QR factorization of first column block in-place
    F = qrUnblocked!(A1, view(τ, 1:min(m, n, blocksize)))

    # Apply the QR factorization to the trailing columns (if any) and recurse
    if n > blocksize
        # Make a view of the trailing columns
        A2 = view(A, :, blocksize+1:n)
        # Apply Q' to the trailing columns
        lmul!(F[Tuple{:QBlocked}]', A2, view(work, 1:min(m, blocksize), 1:(n-blocksize)))
    end

    # Compute QR factorization of trailing block
    if m > blocksize && n > blocksize
        qrBlocked!(
            view(A, (blocksize+1):m, (blocksize+1):n),
            blocksize,
            view(τ, (blocksize+1):min(m, n)),
            work,
        )
    end

    return QR2{T,typeof(A),typeof(τ)}(A, τ)
end

module LAPACK2

using libblastrampoline_jll
using LinearAlgebra
using LinearAlgebra: BlasInt, chkstride1, LAPACKException
using LinearAlgebra.BLAS: @blasfunc
using LinearAlgebra.LAPACK: chkdiag, chkside, chkuplo

liblapack_name = libblastrampoline_jll.libblastrampoline

## Standard QR/QL
function steqr!(
    compz::Char,
    d::StridedVector{Float64},
    e::StridedVector{Float64},
    Z::StridedMatrix{Float64} = compz == 'N' ? Matrix{Float64}(undef, 0, 0) :
                                Matrix{Float64}(undef, length(d), length(d)),
    work::StridedVector{Float64} = compz == 'N' ? Vector{Float64}(undef, 0) :
                                   Vector{Float64}(undef, max(1, 2 * length(d) - 2)),
)

    # Extract sizes
    n = length(d)
    ldz = stride(Z, 2)

    # Checks
    length(e) + 1 == n || throw(DimensionMismatch(""))
    if compz == 'N'
    elseif compz in ('V', 'I')
        chkstride1(Z)
        n <= size(Z, 1) || throw(DimensionMismatch("Z matrix has too few rows"))
        n <= size(Z, 2) || throw(DimensionMismatch("Z matrix has too few colums"))
    else
        throw(ArgumentError("compz must be either 'N', 'V', or 'I'"))
    end

    # Allocations
    info = Vector{BlasInt}(undef, 1)

    ccall(
        (@blasfunc("dsteqr_"), liblapack_name),
        Cvoid,
        (
            Ref{UInt8},
            Ref{BlasInt},
            Ptr{Float64},
            Ptr{Float64},
            Ptr{Float64},
            Ref{BlasInt},
            Ptr{Float64},
            Ptr{BlasInt},
        ),
        compz,
        n,
        d,
        e,
        Z,
        max(1, ldz),
        work,
        info,
    )
    info[1] == 0 || throw(LAPACKException(info[1]))

    return d, Z
end

## Square root free QR/QL (values only, but fast)
function sterf!(d::StridedVector{Float64}, e::StridedVector{Float64})

    # Extract sizes
    n = length(d)

    # Checks
    length(e) >= n - 1 || throw(DimensionMismatch("subdiagonal is too short"))

    # Allocations
    info = BlasInt[0]

    ccall(
        (@blasfunc("dsterf_"), liblapack_name),
        Cvoid,
        (Ref{BlasInt}, Ptr{Float64}, Ptr{Float64}, Ptr{BlasInt}),
        n,
        d,
        e,
        info,
    )

    info[1] == 0 || throw(LAPACKException(info[1]))

    d
end

## Divide and Conquer
function stedc!(
    compz::Char,
    d::StridedVector{Float64},
    e::StridedVector{Float64},
    Z::StridedMatrix{Float64},
    work::StridedVector{Float64},
    lwork::BlasInt,
    iwork::StridedVector{BlasInt},
    liwork::BlasInt,
)

    # Extract sizes
    n = length(d)
    ldz = stride(Z, 2)

    # Checks
    length(e) + 1 == n || throw(DimensionMismatch(""))
    # length(work)
    # length(lwork)

    # Allocations
    info = BlasInt[0]

    ccall(
        (@blasfunc("dstedc_"), liblapack_name),
        Cvoid,
        (
            Ref{UInt8},
            Ref{BlasInt},
            Ptr{Float64},
            Ptr{Float64},
            Ptr{Float64},
            Ref{BlasInt},
            Ptr{Float64},
            Ref{BlasInt},
            Ptr{BlasInt},
            Ref{BlasInt},
            Ptr{BlasInt},
        ),
        compz,
        n,
        d,
        e,
        Z,
        max(1, ldz),
        work,
        lwork,
        iwork,
        liwork,
        info,
    )

    info[1] == 0 || throw(LAPACKException(info[1]))

    return d, Z
end

function stedc!(
    compz::Char,
    d::StridedVector{Float64},
    e::StridedVector{Float64},
    Z::StridedMatrix{Float64} = compz == 'N' ? Matrix{Float64}(undef, 0, 0) :
                                Matrix{Float64}(undef, length(d), length(d)),
)

    work::Vector{Float64} = Float64[0]
    iwork::Vector{BlasInt} = BlasInt[0]
    stedc!(compz, d, e, Z, work, -1, iwork, -1)

    lwork::BlasInt = work[1]
    work = Vector{Float64}(undef, lwork)
    liwork = iwork[1]
    iwork = Vector{BlasInt}(undef, liwork)

    return stedc!(compz, d, e, Z, work, lwork, iwork, liwork)
end

## RRR
for (lsymb, elty) in ((:dstemr_, :Float64), (:sstemr_, :Float32))
    @eval begin
        function stemr!(
            jobz::Char,
            range::Char,
            dv::StridedVector{$elty},
            ev::StridedVector{$elty},
            vl::$elty,
            vu::$elty,
            il::BlasInt,
            iu::BlasInt,
            w::StridedVector{$elty},
            Z::StridedMatrix{$elty},
            nzc::BlasInt,
            isuppz::StridedVector{BlasInt},
            work::StridedVector{$elty},
            lwork::BlasInt,
            iwork::StridedVector{BlasInt},
            liwork::BlasInt,
        )

            # Extract sizes
            n = length(dv)
            ldz = stride(Z, 2)

            # Checks
            length(ev) >= n - 1 || throw(DimensionMismatch("subdiagonal is too short"))

            # Allocations
            eev::Vector{$elty} = length(ev) == n - 1 ? [ev; zero($elty)] : copy(ev)
            abstol = Vector{$elty}(undef, 1)
            m = Vector{BlasInt}(undef, 1)
            tryrac = BlasInt[1]
            info = Vector{BlasInt}(undef, 1)

            ccall(
                (@blasfunc($lsymb), liblapack_name),
                Cvoid,
                (
                    Ref{UInt8},
                    Ref{UInt8},
                    Ref{BlasInt},
                    Ptr{$elty},
                    Ptr{$elty},
                    Ref{$elty},
                    Ref{$elty},
                    Ref{BlasInt},
                    Ref{BlasInt},
                    Ptr{BlasInt},
                    Ptr{$elty},
                    Ptr{$elty},
                    Ref{BlasInt},
                    Ref{BlasInt},
                    Ptr{BlasInt},
                    Ptr{BlasInt},
                    Ptr{$elty},
                    Ref{BlasInt},
                    Ptr{BlasInt},
                    Ref{BlasInt},
                    Ptr{BlasInt},
                ),
                jobz,
                range,
                n,
                dv,
                eev,
                vl,
                vu,
                il,
                iu,
                m,
                w,
                Z,
                max(1, ldz),
                nzc,
                isuppz,
                tryrac,
                work,
                lwork,
                iwork,
                liwork,
                info,
            )

            info[1] == 0 || throw(LAPACKException(info[1]))

            w, Z, tryrac[1]
        end

        function stemr!(
            jobz::Char,
            range::Char,
            dv::StridedVector{$elty},
            ev::StridedVector{$elty},
            vl::$elty = typemin($elty),
            vu::$elty = typemax($elty),
            il::BlasInt = 1,
            iu::BlasInt = length(dv),
        )

            n = length(dv)
            w = Vector{$elty}(undef, n)
            if jobz == 'N'
                # Z = Matrix{$elty}(0, 0)
                nzc::BlasInt = 0
                isuppz = Vector{BlasInt}(undef, 0)
            elseif jobz == 'V'
                nzc = -1
                isuppz = similar(dv, BlasInt, 2n)
            else
                throw(ArgumentError("jobz must be either 'N' or 'V'"))
            end

            work = Vector{$elty}(undef, 1)
            lwork::BlasInt = -1
            iwork = BlasInt[0]
            liwork::BlasInt = -1
            Z = Matrix{$elty}(undef, jobz == 'N' ? 1 : n, 1)
            nzc = -1

            stemr!(
                jobz,
                range,
                dv,
                ev,
                vl,
                vu,
                il,
                iu,
                w,
                Z,
                nzc,
                isuppz,
                work,
                lwork,
                iwork,
                liwork,
            )

            lwork = work[1]
            work = Vector{$elty}(undef, lwork)
            liwork = iwork[1]
            iwork = Vector{BlasInt}(undef, liwork)
            nzc = Z[1]
            Z = similar(dv, $elty, n, nzc)

            return stemr!(
                jobz,
                range,
                dv,
                ev,
                vl,
                vu,
                il,
                iu,
                w,
                Z,
                nzc,
                isuppz,
                work,
                lwork,
                iwork,
                liwork,
            )
        end
    end
end

# Non-symmetric eigenvalue problem
function lahqr!(
    wantt::Bool,
    wantz::Bool,
    H::StridedMatrix{Float64},
    ilo::Integer,
    ihi::Integer,
    wr::StridedVector{Float64},
    wi::StridedVector{Float64},
    iloz::Integer,
    ihiz::Integer,
    Z::StridedMatrix{Float64},
)
    # SUBROUTINE DLAHQR( WANTT, WANTZ, N, ILO, IHI, H, LDH, WR, WI,
    #                         ILOZ, IHIZ, Z, LDZ, INFO )

    #      .. Scalar Arguments ..
    #      INTEGER            IHI, IHIZ, ILO, ILOZ, INFO, LDH, LDZ, N
    #      LOGICAL            WANTT, WANTZ
    #      ..
    #      .. Array Arguments ..
    #      DOUBLE PRECISION   H( LDH, * ), WI( * ), WR( * ), Z( LDZ, * )

    n = LinearAlgebra.checksquare(H)
    ldh = stride(H, 2)
    ldz = stride(Z, 2)

    info = Ref{BlasInt}(0)

    ccall(
        (@blasfunc("dlahqr_"), liblapack_name),
        Cvoid,
        (
            Ref{BlasInt},
            Ref{BlasInt},
            Ref{BlasInt},
            Ref{BlasInt},
            Ref{BlasInt},
            Ptr{Float64},
            Ref{BlasInt},
            Ptr{Float64},
            Ptr{Float64},
            Ref{BlasInt},
            Ref{BlasInt},
            Ptr{Float64},
            Ref{BlasInt},
            Ptr{BlasInt},
        ),
        wantt,
        wantz,
        n,
        ilo,
        ihi,
        H,
        max(1, ldh),
        wr,
        wi,
        iloz,
        ihiz,
        Z,
        max(1, ldz),
        info,
    )

    if info[] != 0
        throw(LAPACKException(info[]))
    end

    return wr, wi, Z
end
function lahqr!(H::StridedMatrix{Float64})
    n = size(H, 1)
    return lahqr!(
        false,
        false,
        H,
        1,
        n,
        Vector{Float64}(undef, n),
        Vector{Float64}(undef, n),
        1,
        1,
        Matrix{Float64}(undef, 0, 0),
    )
end

## Cholesky + singular values
function pteqr!(
    compz::Char,
    d::StridedVector{Float64},
    e::StridedVector{Float64},
    Z::StridedMatrix{Float64},
    work::StridedVector{Float64},
)
    n = length(d)
    ldz = stride(Z, 2)

    # Checks
    if length(e) < n - 1
        throw(DimensionMismatch("subdiagonal vector is too short"))
    end
    chkstride1(d)
    chkstride1(e)
    chkstride1(Z)
    if compz == 'N'
    elseif compz ∈ ('V', 'I')
        if size(Z, 1) < n
            throw(DimensionMismatch("Z does not have enough rows"))
        end
        if size(Z, 2) < ldz
            throw(DimensionMismatch("Z does not have enough columns"))
        end
    else
        throw(ArgumentError("compz must be either 'N', 'V', or 'I'"))
    end

    info = Ref{BlasInt}(1)

    ccall(
        (@blasfunc(dpteqr_), liblapack_name),
        Cvoid,
        (
            Ref{UInt8},
            Ref{BlasInt},
            Ptr{Float64},
            Ptr{Float64},
            Ptr{Float64},
            Ref{BlasInt},
            Ptr{Float64},
            Ref{BlasInt},
        ),
        compz,
        n,
        d,
        e,
        Z,
        max(1, ldz),
        work,
        info,
    )

    if info[] != 0
        throw(LAPACKException(info[]))
    end

    return d, Z
end

function pteqr!(compz::Char, d::StridedVector{Float64}, e::StridedVector{Float64})
    n = length(d)

    Z = if compz == 'I'
        Matrix{Float64}(undef, n, n)
    else
        Matrix{Float64}(undef, 0, 0)
    end
    work = Vector{Float64}(undef, 4 * n)
    return pteqr!(compz, d, e, Z, work)
end

# Gu's dnc eigensolver
for (f, elty) in ((:dsyevd_, :Float64), (:ssyevd_, :Float32))

    @eval begin
        function syevd!(jobz::Char, uplo::Char, A::StridedMatrix{$elty})
            n = LinearAlgebra.checksquare(A)
            lda = stride(A, 2)
            w = Vector{$elty}(undef, n)
            work = Vector{$elty}(undef, 1)
            lwork = BlasInt(-1)
            iwork = Vector{BlasInt}(undef, 1)
            liwork = BlasInt(-1)
            info = Ref(BlasInt(0))
            for i = 1:2
                ccall(
                    (@blasfunc($f), liblapack_name),
                    Cvoid,
                    (
                        Ref{UInt8},
                        Ref{UInt8},
                        Ref{BlasInt},
                        Ptr{$elty},
                        Ref{BlasInt},
                        Ptr{$elty},
                        Ptr{$elty},
                        Ref{BlasInt},
                        Ptr{BlasInt},
                        Ref{BlasInt},
                        Ref{BlasInt},
                    ),
                    jobz,
                    uplo,
                    n,
                    A,
                    lda,
                    w,
                    work,
                    lwork,
                    iwork,
                    liwork,
                    info,
                )

                if info[] != 0
                    return LinearAlgebra.LAPACKException(info[])
                end
                if i == 1
                    lwork = BlasInt(work[1])
                    resize!(work, lwork)
                    liwork = iwork[1]
                    resize!(iwork, liwork)
                end
            end
            return w, A
        end
    end
end
for (f, elty, relty) in
    ((:zheevd_, :ComplexF64, :Float64), (:cheevd_, :ComplexF32, :Float32))

    @eval begin
        function heevd!(jobz::Char, uplo::Char, A::StridedMatrix{$elty})
            n = LinearAlgebra.checksquare(A)
            lda = stride(A, 2)
            w = Vector{$relty}(undef, n)
            work = Vector{$elty}(undef, 1)
            lwork = BlasInt(-1)
            rwork = Vector{$relty}(undef, 1)
            lrwork = BlasInt(-1)
            iwork = Vector{BlasInt}(undef, 1)
            liwork = BlasInt(-1)
            info = Ref(BlasInt(0))
            for i = 1:2
                ccall(
                    (@blasfunc($f), liblapack_name),
                    Cvoid,
                    (
                        Ref{UInt8},
                        Ref{UInt8},
                        Ref{BlasInt},
                        Ptr{$elty},
                        Ref{BlasInt},
                        Ptr{$relty},
                        Ptr{$elty},
                        Ref{BlasInt},
                        Ptr{$relty},
                        Ref{BlasInt},
                        Ptr{BlasInt},
                        Ref{BlasInt},
                        Ref{BlasInt},
                    ),
                    jobz,
                    uplo,
                    n,
                    A,
                    lda,
                    w,
                    work,
                    lwork,
                    rwork,
                    lrwork,
                    iwork,
                    liwork,
                    info,
                )

                if info[] != 0
                    return LinearAlgebra.LAPACKException(info[])
                end

                if i == 1
                    lwork = BlasInt(work[1])
                    resize!(work, lwork)
                    lrwork = BlasInt(rwork[1])
                    resize!(rwork, lrwork)
                    liwork = iwork[1]
                    resize!(iwork, liwork)
                end
            end
            return w, A
        end
    end
end

# Generalized Eigen
## Eigenvectors of (pseudo) triangular matrices
for (f, elty) in ((:dtgevc_, :Float64), (:stgevc_, :Float32))

    @eval begin
        function tgevc!(
            side::Char,
            howmny::Char,
            select::Vector{BlasInt},
            S::StridedMatrix{$elty},
            P::StridedMatrix{$elty},
            VL::StridedMatrix{$elty},
            VR::StridedMatrix{$elty},
            work::Vector{$elty},
        )

            n = LinearAlgebra.checksquare(S)
            if LinearAlgebra.checksquare(P) != n
                throw(DimensionMismatch("the two matrices must have same size"))
            end

            lds, ldp, ldvl, ldvr = stride(S, 2), stride(P, 2), stride(VL, 2), stride(VR, 2)
            if side == 'L'
                mm = size(VL, 2)
                if size(VL, 1) != n
                    throw(
                        DimensionMismatch(
                            "first dimension of output is $size(VL, 1) but should be $n",
                        ),
                    )
                end
            elseif side == 'R'
                mm = size(VR, 2)
                if size(VR, 1) != n
                    throw(
                        DimensionMismatch(
                            "first dimension of output is $size(VR, 1) but should be $n",
                        ),
                    )
                end
            elseif side == 'B'
                mm = size(VL, 2)
                if mm != size(VR, 2)
                    throw(
                        DimensionMismatch(
                            "the matrices for storing the left and right eigenvectors must have the same number of columns when side == 'B'",
                        ),
                    )
                end
                if size(VL, 1) != n
                    throw(
                        DimensionMismatch(
                            "first dimension of output is $size(VL, 1) but should be $n",
                        ),
                    )
                end
            else
                if size(VR, 1) != n
                    throw(
                        DimensionMismatch(
                            "first dimension of output is $size(VR, 1) but should be $n",
                        ),
                    )
                end
                throw(ArgumentError("side must be either 'L', 'R', or 'B'"))
            end
            if howmny == 'A' || howmny == 'B'
                if mm != n
                    throw(
                        DimensionMismatch(
                            "the number of columns in the output matrices are $mm, but should be $n",
                        ),
                    )
                end
            elseif howmny == 'S'
                mx, mn = extrema(select)
                if mx > 1 || mn < 0
                    throw(ArgumentError("the elements of select must be either 0 or 1"))
                end
                if sum(select) != mm
                    throw(
                        DimensionMismatch(
                            "the number of columns in the output arrays is $mm, but you have selected $(sum(select)) vectors",
                        ),
                    )
                end
            else
                throw(ArgumentError("howmny must be either A, B, or S but was $howmny"))
            end

            m = Ref(BlasInt(0))
            info = Ref(BlasInt(0))

            ccall(
                (@blasfunc($f), liblapack_name),
                Cvoid,
                (
                    Ref{UInt8},
                    Ref{UInt8},
                    Ptr{BlasInt},
                    Ref{BlasInt},
                    Ptr{$elty},
                    Ref{BlasInt},
                    Ptr{$elty},
                    Ref{BlasInt},
                    Ptr{$elty},
                    Ref{BlasInt},
                    Ptr{$elty},
                    Ref{BlasInt},
                    Ref{BlasInt},
                    Ref{BlasInt},
                    Ptr{$elty},
                    Ref{BlasInt},
                ),
                side,
                howmny,
                select,
                n,
                S,
                lds,
                P,
                ldp,
                VL,
                ldvl,
                VR,
                ldvr,
                mm,
                m,
                work,
                info,
            )

            if info[] != 0
                throw(LAPACKException(info[]))
            end

            return VL, VR, m[]
        end

        function tgevc!(
            side::Char,
            howmny::Char,
            select::Vector{BlasInt},
            S::StridedMatrix{$elty},
            P::StridedMatrix{$elty},
            VL::StridedMatrix{$elty},
            VR::StridedMatrix{$elty},
        )

            n = LinearAlgebra.checksquare(S)
            work = Vector{$elty}(undef, 6n)

            return tgevc!(side, howmny, select, S, P, VL, VR, work)
        end

        function tgevc!(
            side::Char,
            howmny::Char,
            select::Vector{BlasInt},
            S::StridedMatrix{$elty},
            P::StridedMatrix{$elty},
        )
            # No checks here as they are done in method above
            n = LinearAlgebra.checksquare(S)
            if side == 'L'
                VR = Matrix{$elty}(undef, n, 0)
                if howmny == 'A' || howmny == 'B'
                    VL = Matrix{$elty}(undef, n, n)
                else
                    VL = Matrix{$elty}(undef, n, sum(select))
                end
            elseif side == 'R'
                VL = Matrix{$elty}(undef, n, 0)
                if howmny == 'A' || howmny == 'B'
                    VR = Matrix{$elty}(undef, n, n)
                else
                    VR = Matrix{$elty}(undef, n, sum(select))
                end
            else
                if howmny == 'A' || howmny == 'B'
                    VL = Matrix{$elty}(undef, n, n)
                    VR = Matrix{$elty}(undef, n, n)
                else
                    VL = Matrix{$elty}(undef, n, sum(select))
                    VR = Matrix{$elty}(undef, n, sum(select))
                end
            end

            return tgevc!(side, howmny, select, S, P, VL, VR)
        end
    end
end

end

using LinearAlgebra: rdiv!

function cholUnblocked!(A::AbstractMatrix{T}, ::Type{Val{:L}}) where {T<:Number}
    n = LinearAlgebra.checksquare(A)
    A[1, 1] = sqrt(A[1, 1])
    if n > 1
        a21 = view(A, 2:n, 1)
        rmul!(a21, inv(real(A[1, 1])))

        A22 = view(A, 2:n, 2:n)
        rankUpdate!(Hermitian(A22, :L), a21, -1)
        cholUnblocked!(A22, Val{:L})
    end
    A
end

function cholBlocked!(
    A::AbstractMatrix{T},
    ::Type{Val{:L}},
    blocksize::Integer,
) where {T<:Number}
    n = LinearAlgebra.checksquare(A)
    mnb = min(n, blocksize)
    A11 = view(A, 1:mnb, 1:mnb)
    cholUnblocked!(A11, Val{:L})
    if n > blocksize
        A21 = view(A, (blocksize+1):n, 1:blocksize)
        rdiv!(A21, LowerTriangular(A11)')

        A22 = view(A, (blocksize+1):n, (blocksize+1):n)
        rankUpdate!(Hermitian(A22, :L), A21, -1)
        cholBlocked!(A22, Val{:L}, blocksize)
    end
    A
end

function cholRecursive!(A::StridedMatrix{T}, ::Type{Val{:L}}, cutoff = 1) where {T}
    n = LinearAlgebra.checksquare(A)
    if n == 1
        A[1, 1] = sqrt(A[1, 1])
    elseif n < cutoff
        cholUnblocked!(A, Val{:L})
    else
        n2 = div(n, 2)
        A11 = view(A, 1:n2, 1:n2)
        cholRecursive!(A11, Val{:L})
        A21 = view(A, n2+1:n, 1:n2)
        rdiv!(A21, LowerTriangular(A11)')

        A22 = view(A, n2+1:n, n2+1:n)
        rankUpdate!(Hermitian(A22, :L), A21, -1)
        cholRecursive!(A22, Val{:L}, cutoff)
    end
    return LowerTriangular(A)
end

using Test, GenericLinearAlgebra, LinearAlgebra, Quaternions

@testset "The selfadjoint eigen problem" begin
    n = 50
    @testset "SymTridiagonal" begin
        # Should automatically dispatch to method defined in this
        # package since a BigFloat methods isn't defined in
        # LinearAlgebra
        T = SymTridiagonal(big.(randn(n)), big.(randn(n - 1)))
        vals, vecs = eigen(T)
        @test issorted(vals)
        @testset "default" begin
            @test (vecs' * T) * vecs ≈ Diagonal(vals)
            @test eigvals(T) ≈ vals
            @test vecs'vecs ≈ Matrix(I, n, n)
        end

        @testset "eigen2" begin
            vals2, vecs2 = GenericLinearAlgebra.eigen2(T)
            @test issorted(vals2)
            @test vals ≈ vals2
            @test vecs[[1, n], :] == vecs2
            @test vecs2 * vecs2' ≈ Matrix(I, 2, 2)
        end

        @testset "QR version (QL is default)" begin
            vals, vecs =
                GenericLinearAlgebra.eigQR!(copy(T), vectors = Matrix{eltype(T)}(I, n, n))
            @test (vecs' * T) * vecs ≈ Diagonal(vals)
            @test eigvals(T) ≈ sort(vals)
            @test vecs'vecs ≈ Matrix(I, n, n)
        end
    end

    @testset "(full) Symmetric" for uplo in (:L, :U)
        A = Symmetric(big.(randn(n, n)), uplo)
        vals, vecs = @inferred(eigen(A))
        @testset "default" begin
            @test vecs' * A * vecs ≈ diagm(0 => vals)
            @test @inferred(eigvals(A)) ≈ vals
            @test vecs'vecs ≈ Matrix(I, n, n)
            @test issorted(vals)
        end

        @testset "eigen2" begin
            vals2, vecs2 = @inferred(GenericLinearAlgebra.eigen2(A))
            @test vals ≈ vals2
            @test vecs[[1, n], :] ≈ vecs2
            @test vecs2 * vecs2' ≈ Matrix(I, 2, 2)
            @test issorted(vals2)
        end
    end

    @testset "(full) Quaternion Hermitian using :$uplo" for uplo in (:L, :U)
        V = qr([Quaternion(randn(4)...) for i = 1:n, j = 1:n]).Q
        λ = 10 .^ range(-8, stop = 0, length = n)
        A = Hermitian(V * Diagonal(λ) * V' |> t -> (t + t') / 2, uplo)
        vals, vecs = eigen(A)
        @test issorted(vals)

        @testset "symtri!" begin
            T = GenericLinearAlgebra.symtri!(copy(A))
            Q = Array(T.reflectors)
            @test Q == lmul!(T.reflectors, Matrix{eltype(A)}(I, size(A)...))
            @test Q ≈ rmul!(Matrix{eltype(A)}(I, size(A)...), T.reflectors)
            @test Q'Q ≈ Q*Q' ≈ I
            @test Q' * A * Q ≈ T.diagonals
        end

        @testset "default" begin
            @test A * vecs ≈ vecs * Diagonal(vals)
            @test eigvals(A) ≈ vals
            @test vals ≈ λ rtol = 1e-13 * n
            @test vecs'vecs ≈ Matrix(I, n, n)
        end

        @testset "eigen2" begin
            vals2, vecs2 = GenericLinearAlgebra.eigen2(A)
            @test issorted(vals2)
            @test vals ≈ vals2
            @test vecs[[1, n], :] ≈ vecs2
            @test vecs2 * vecs2' ≈ Matrix(I, 2, 2)
        end
    end

    @testset "big Hermitian{<:Complex}" begin
        # This one used to cause an ambiguity error. See #35
        A = complex.(randn(4, 4), randn(4, 4))
        @test Float64.(eigen(Hermitian(big.(A))).values) ≈ eigen(Hermitian(copy(A))).values
        @test Float64.(eigvals(Hermitian(big.(A)))) ≈ eigvals(Hermitian(copy(A)))
    end

    @testset "generic Givens" begin
        x, y = randn(2)
        c, s, r = invoke(LinearAlgebra.givensAlgorithm, Tuple{Real,Real}, x, y)
        @test c * x + s * y ≈ r
        @test c * y ≈ s * x
    end

    @testset "out-of-bounds issue in 1x1 case" begin
        @test GenericLinearAlgebra._eigvals!(SymTridiagonal([1.0], Float64[])) == [1.0]
        @test GenericLinearAlgebra._eigen!(SymTridiagonal([1.0], Float64[])).values == [1.0]
        @test GenericLinearAlgebra._eigen!(SymTridiagonal([1.0], Float64[])).vectors ==
              fill(1.0, 1, 1)
    end

    # Issue #52
    @testset "convergence criterion when diagonal has zeros" begin
        M1 = Hermitian(zeros(3, 3))
        M1[1, 1] = 0.01
        M2 = Hermitian(zeros(3, 3))
        M2[3, 3] = 0.01
        @test eigvals(M1) == GenericLinearAlgebra._eigvals!(copy(M1))
        @test eigvals(M2) == GenericLinearAlgebra._eigvals!(copy(M2))
        @test eigen(M1).values == GenericLinearAlgebra._eigen!(copy(M1)).values
        @test eigen(M2).values == GenericLinearAlgebra._eigen!(copy(M2)).values
    end

    @testset "Sorting of `ishermitian(T)==true` matrices on pre-1.2" begin
        T = big.(randn(5, 5))
        T = T + T'
        @test issorted(eigvals(T))
    end

    @testset "issue 123" begin
        M = Hermitian([
            big"-0.4080898675832881399369478084264191594976530854542904557798567397269356887436951" big"-0.1032324294981949906363774065395184125237581835226155628209100984396171211818558" big"-1.0795157507124452910839896877334667387210301781514938067860918240771876343947" big"0.9172086645212876240254394768180975107502376572771647296150618931226550446699544";
            big"-0.1032324294981949906363774065395184125237581835226155628209100984396171211818558" big"-0.9819956883377066621250198846550622559246996804965712336465013506629992739010227" big"0.1882735697944729855991976669864503854920622386133987141371224931350749728226066" big"-0.1599663084136352437739757607131301560774255778371317602542426234968564801904052";
            big"-1.0795157507124452910839896877334667387210301781514938067860918240771876343947" big"0.1882735697944729855991976669864503854920622386133987141371224931350749728226066" big"0.9688026817149176598146701814747478080649943014810992426739997593840858865727305" big"-1.672789745967021000172452940954243617442140494364475046869527486458478435262502";
            big"0.9172086645212876240254394768180975107502376572771647296150618931226550446699544" big"-0.1599663084136352437739757607131301560774255778371317602542426234968564801904052" big"-1.672789745967021000172452940954243617442140494364475046869527486458478435262502" big"0.4212828742060771422472975116067336073573584644697624467523583310058490760719874"
        ])
        F = eigen(M)
        @test M * F.vectors ≈ F.vectors * Diagonal(F.values)

        @testset "2x2 cases, d: $d, e: $e" for (d, e) in (
            ([1.0, 1.0], [0.0]),
            ([0.0, 0.0], [1.0]),
            ([1.0, 1.0], [1e-20]),
            ([1e-20, 1e-30], [0.5]),
            ([1e-20, 1e-30], [1e-10]),
            ([1e-20, 1e-30], [1e-40]),
            ([1e20, 1e30], [0.5]),
            ([1e20, 1e30], [1e10]),
            ([1e20, 1e30], [1e40])
        )
            V = Matrix{Float64}(I, 2, 2)
            c, s = GenericLinearAlgebra.eig2x2!(d, e, 1, V)
            @test hypot(c, s) ≈ 1
        end
    end

    @testset "#133" begin
        A = SymTridiagonal{BigFloat}(randn(5), randn(4))
        T = Tridiagonal(A)
        if VERSION ≥ v"1.10"
            # The following depends on more recent behaviour of eigvals/eigen in stdlib
            @test eigvals(A) == eigvals(T) == eigvals(A; sortby=LinearAlgebra.eigsortby) == eigvals(T; sortby=LinearAlgebra.eigsortby) ==  eigvals!(deepcopy(A); sortby=LinearAlgebra.eigsortby)
            @test eigen(A).values == eigen(T).values == eigen(A; sortby=LinearAlgebra.eigsortby).values == eigen(T; sortby=LinearAlgebra.eigsortby).values
            # compare abs to avoid sign issues
            @test abs.(eigen(A).vectors) == abs.(eigen(T).vectors) == abs.(eigen(A; sortby=LinearAlgebra.eigsortby).vectors) == abs.(eigen(T; sortby=LinearAlgebra.eigsortby).vectors)
        end
    end

    if VERSION >= v"1.9"
        @testset "#139" begin
            A = Hermitian(Diagonal([1.0, 2.0]))
            @test eigvals(A) == diag(A)
            @test eigen(A).values == diag(A)
        end
    end

    if VERSION >= v"1.11"
        @testset "Method ambiguity in eigen with Julia 1.11 #141" begin
            M = Hermitian(Tridiagonal(ones(ComplexF64, 2), ones(ComplexF64, 3), ones(ComplexF64, 2)))
            @test eigen(M).values ≈ Float64.(eigen(big.(M)).values)
        end
    end
end

################################################
## Specialized routines for tridiagonal matrices
################################################

export numnegevals

"""
Computes the number of negative eigenvalues of T - σI, a.k.a. spectrum slicing

Inputs:
    T: A SymTridiagonal{<:Real} matrix
    σ: The shift parameter

Outputs:
    ν: The number of negative eigenvalues

Reference:
    B. N. Parlett, "The symmetric eigenvalue problem", Section 3.3.1, p. 52.
"""
function numnegevals(T::SymTridiagonal{S}, σ::S = zero(S)) where {S}
    α = T.dv
    β = T.ev
    n = length(α)
    ϵ = eps(S)
    δ = α[1] - σ
    ν = δ < 0 ? 1 : 0
    for k = 1:n-1
        if δ == 0
            info("zero in iteration $k")
            δ = ϵ * (β[k] + ϵ) #Parlett prefers adjusting σ and starting again
        end
        δ = (α[k+1] - σ) - β[k] * (β[k] / δ)
        ν += (δ < 0)
    end
    ν
end

using Test, GenericLinearAlgebra, LinearAlgebra
using GenericLinearAlgebra.LAPACK2

@testset "LAPACK wrappers" begin

    n = 100

    T = SymTridiagonal(randn(n), randn(n - 1))
    vals, vecs = eigen(T)
    @testset "steqr" begin
        _vals, _vecs = LAPACK2.steqr!('N', copy(T.dv), copy(T.ev))
        @test vals ≈ _vals

        _vals, _vecs = LAPACK2.steqr!('I', copy(T.dv), copy(T.ev))
        @test vals ≈ _vals
        @test abs.(_vecs'vecs) ≈ Matrix(I, n, n)

        _vals, _vecs = LAPACK2.steqr!('V', copy(T.dv), copy(T.ev), Matrix{Float64}(I, n, n))
        @test vals ≈ _vals
        @test abs.(_vecs'vecs) ≈ Matrix(I, n, n)
    end

    @testset "sterf" begin
        _vals = LAPACK2.sterf!(copy(T.dv), copy(T.ev))
        @test _vals ≈ vals
    end

    @testset "stedc" begin
        _vals, _vecs = LAPACK2.stedc!('N', copy(T.dv), copy(T.ev))
        @test vals ≈ _vals

        _vals, _vecs = LAPACK2.stedc!('I', copy(T.dv), copy(T.ev))
        @test vals ≈ _vals
        @test abs.(_vecs'vecs) ≈ Matrix(I, n, n)

        _vals, _vecs = LAPACK2.stedc!('V', copy(T.dv), copy(T.ev), Matrix{Float64}(I, n, n))
        @test vals ≈ _vals
        @test abs.(_vecs'vecs) ≈ Matrix(I, n, n)
    end

    @testset "stemr" begin
        _vals, _vecs, __ = LAPACK2.stemr!('N', 'A', copy(T.dv), copy(T.ev))
        @test vals ≈ _vals

        _vals, _vecs, __ = LAPACK2.stemr!('N', 'V', copy(T.dv), copy(T.ev))
        @test vals ≈ _vals

        _vals, _vecs, __ = LAPACK2.stemr!('N', 'I', copy(T.dv), copy(T.ev))
        @test vals ≈ _vals

        _vals, _vecs, __ = LAPACK2.stemr!('V', 'A', copy(T.dv), copy(T.ev))
        @test vals ≈ _vals
        @test abs.(_vecs'vecs) ≈ Matrix(I, n, n)

        _vals, _vecs, __ = LAPACK2.stemr!('V', 'V', copy(T.dv), copy(T.ev))
        @test vals ≈ _vals
        @test abs.(_vecs'vecs) ≈ Matrix(I, n, n)

        _vals, _vecs, __ = LAPACK2.stemr!('V', 'I', copy(T.dv), copy(T.ev))
        @test vals ≈ _vals
        @test abs.(_vecs'vecs) ≈ Matrix(I, n, n)
    end

    @testset "lahqr" begin
        T = Array(Tridiagonal(fill(0.1, 99), fill(0.0, 100), fill(40.0, 99)))
        _vals = sort(LAPACK2.lahqr!(copy(T))[1])
        @test _vals ≈ sort(real.(GenericLinearAlgebra._eigvals!(copy(T))))
        # LAPACK's multishift algorithm (the default) seems to be broken
        @test !(_vals ≈ sort(eigvals(T)))
    end

    @testset "syevd: eltype=$eltype, uplo=$uplo" for eltype in (
            Float32,
            Float64,
            ComplexF32,
            ComplexF64,
        ),
        uplo in ('U', 'L')

        A = randn(eltype, n, n)
        A = A + A'
        if eltype <: Real
            vals, vecs = LAPACK2.syevd!('V', uplo, copy(A))
        else
            vals, vecs = LAPACK2.heevd!('V', uplo, copy(A))
        end
        @test diag(vecs' * A * vecs) ≈ eigvals(A)
    end

    @testset "tgevc: eltype=$eltype, side=$side, howmny=$howmny" for eltype in
                                                                     (Float32, Float64),
        side in ('L', 'R', 'B'),
        howmny in ('A', 'S')

        select = ones(Int, n)
        S, P = triu(randn(eltype, n, n)), triu(randn(eltype, n, n))
        VL, VR, m = LAPACK2.tgevc!(side, howmny, select, copy(S), copy(P))
        if side ∈ ('R', 'B')
            w = diag(S * VR) ./ diag(P * VR)
            @test S * VR ≈ P * VR * Diagonal(w) rtol = sqrt(eps(eltype)) atol =
                sqrt(eps(eltype))
        end
        if side ∈ ('L', 'B')
            w = w = diag(VL' * S) ./ diag(VL' * P)
            @test VL' * S ≈ Diagonal(w) * VL' * P rtol = sqrt(eps(eltype)) atol =
                sqrt(eps(eltype))
        end
    end

    @testset "pteqr" begin
        d = fill(10.0, n)
        e = fill(1.0, n - 1)
        vals, vecs = LAPACK2.pteqr!('I', copy(d), copy(e))
        @test SymTridiagonal(d, e) ≈ vecs * Diagonal(vals) * vecs'

        vals2, _ = LAPACK2.pteqr!('N', copy(d), copy(e))
        @test vals ≈ vals2
    end
end

using Printf
using LinearAlgebra
using LinearAlgebra: Givens, Rotation, givens

import Base: \

# Hessenberg Matrix
struct HessenbergMatrix{T,S<:StridedMatrix} <: AbstractMatrix{T}
    data::S
end

Base.copy(H::HessenbergMatrix{T,S}) where {T,S} = HessenbergMatrix{T,S}(copy(H.data))

Base.getindex(H::HessenbergMatrix{T,S}, i::Integer, j::Integer) where {T,S} =
    i > j + 1 ? zero(T) : H.data[i, j]

Base.size(H::HessenbergMatrix) = size(H.data)
Base.size(H::HessenbergMatrix, i::Integer) = size(H.data, i)

function LinearAlgebra.ldiv!(H::HessenbergMatrix, B::AbstractVecOrMat)
    n = size(H, 1)
    Hd = H.data
    for i = 1:n-1
        G, _ = givens(Hd, i, i + 1, i)
        lmul!(G, view(Hd, 1:n, i:n))
        lmul!(G, B)
    end
    ldiv!(UpperTriangular(Hd), B)
end
(\)(H::HessenbergMatrix, B::AbstractVecOrMat) = ldiv!(copy(H), copy(B))

if VERSION < v"1.10"
    # ensure tests pass on Julia v1.6
    copy_similar(A::AbstractArray, ::Type{T}) where {T} = copyto!(similar(A, T, size(A)), A)
    eigtype(T) = promote_type(Float32, typeof(zero(T)/sqrt(abs2(one(T)))))
    eigencopy_oftype(A, S) = copy_similar(A, S)
    LinearAlgebra.eigvals(A::HessenbergMatrix{T}; kws...) where T = LinearAlgebra.eigvals!(eigencopy_oftype(A, eigtype(T)); kws...)
end

# Hessenberg factorization
struct HessenbergFactorization{T,S<:StridedMatrix,U} <: Factorization{T}
    data::S
    τ::Vector{U}
end

Base.copy(HF::HessenbergFactorization{T,S,U}) where {T,S,U} =
    HessenbergFactorization{T,S,U}(copy(HF.data), copy(HF.τ))

function _hessenberg!(A::StridedMatrix{T}) where {T}
    n = LinearAlgebra.checksquare(A)
    τ = Vector{Householder{T}}(undef, n - 1)
    for i = 1:n-1
        xi = view(A, i+1:n, i)
        t = LinearAlgebra.reflector!(xi)
        H = Householder{T,typeof(xi)}(view(xi, 2:n-i), t)
        τ[i] = H
        lmul!(H', view(A, i+1:n, i+1:n))
        rmul!(view(A, :, i+1:n), H)
    end
    return HessenbergFactorization{T,typeof(A),eltype(τ)}(A, τ)
end
LinearAlgebra.hessenberg!(A::StridedMatrix) = _hessenberg!(A)

Base.size(H::HessenbergFactorization, args...) = size(H.data, args...)

function Base.getproperty(F::HessenbergFactorization, s::Symbol)
    if s === :H
        return HessenbergMatrix{eltype(F.data),typeof(F.data)}(F.data)
    else
        return getfield(F, s)
    end
end

# Schur
struct Schur{T,S<:StridedMatrix} <: Factorization{T}
    data::S
    R::Rotation{T}
end

function Base.getproperty(F::Schur, s::Symbol)
    if s === :T || s === :Schur
        return triu(F.data, -1)
    else
        return getfield(F, s)
    end
end

# We currently absorb extra unsupported keywords in kwargs. These could e.g. be scale and permute. Do we want to check that these are false?
function _schur!(
    H::HessenbergFactorization{T};
    tol = eps(real(T)),
    shiftmethod = :Francis,
    maxiter = 30 * size(H, 1),
) where {T}

    n = size(H, 1)
    istart = 1
    iend = n
    HH = H.data
    τ = Rotation(Givens{T}[])

    # iteration count
    i = 0

    @inbounds while true
        i += 1
        # @debug "iteration" i
        if i > maxiter
            throw(ArgumentError("iteration limit $maxiter reached"))
        end

        # Determine if the matrix splits. Find lowest positioned subdiagonal "zero"
        for _istart = iend-1:-1:1
            if abs(HH[_istart+1, _istart]) <=
               tol * (abs(HH[_istart, _istart]) + abs(HH[_istart+1, _istart+1]))
                # Check if subdiagonal element H[i+1,i] is "zero" such that we can split the matrix

                # Set istart to the beginning of the second block
                istart = _istart + 1

                # @debug "Split!" HH[istart, istart-1] istart

                # Set the subdiagonal element to zero to signal that a split has taken place
                HH[istart, istart-1] = 0
                break
            end

            # If no splits have taken place then we start from the top
            istart = 1
        end

        # if block size is one we deflate
        if istart >= iend
            # @debug "Bottom deflation! Block size is one. New iend is" iend - 1
            iend -= 1

            # and the same for a 2x2 block
        elseif istart + 1 == iend
            # @debug "Bottom deflation! Block size is two. New iend is" iend - 2
            iend -= 2

            # run a QR iteration
            # shift method is specified with shiftmethod kw argument
        else
            Hmm = HH[iend, iend]
            Hm1m1 = HH[iend-1, iend-1]
            if iszero(i % 10)
                # Use Eispack exceptional shift
                β = abs(HH[iend, iend-1]) + abs(HH[iend-1, iend-2])
                d = (Hmm + β)^2 - Hmm * β / 2
                t = 2 * Hmm + 3 * β / 2
            else
                d = Hm1m1 * Hmm - HH[iend, iend-1] * HH[iend-1, iend]
                t = Hm1m1 + Hmm
            end
            # @debug "block start is, block end, d, and t" istart iend d t

            if shiftmethod == :Francis
                # @debug "Francis double shift!" HH[iend, iend-1] HH[iend-1, iend-2]

                doubleShiftQR!(HH, τ, t, d, istart, iend)
            elseif shiftmethod == :Rayleigh
                # @debug "Single shift with Rayleigh shift!" HH[iend, iend-1]

                # Run a bulge chase
                singleShiftQR!(HH, τ, Hmm, istart, iend)
            else
                throw(
                    ArgumentError(
                        "only support supported shift methods are :Francis (default) and :Rayleigh. You supplied $shiftmethod",
                    ),
                )
            end
        end
        if iend <= 2
            break
        end
    end

    return Schur{T,typeof(HH)}(HH, τ)
end
_schur!(A::StridedMatrix; kwargs...) = _schur!(_hessenberg!(A); kwargs...)

# FIXME! Move this method to piracy extension
LinearAlgebra.schur!(A::StridedMatrix; kwargs...) = _schur!(A; kwargs...)

function singleShiftQR!(
    HH::StridedMatrix,
    τ::Rotation,
    shift::Number,
    istart::Integer,
    iend::Integer,
)
    m = size(HH, 1)
    H11 = HH[istart, istart]
    H21 = HH[istart+1, istart]
    if m > istart + 1
        Htmp = HH[istart+2, istart]
        HH[istart+2, istart] = 0
    end
    G, _ = givens(H11 - shift, H21, istart, istart + 1)
    lmul!(G, view(HH, :, istart:m))
    rmul!(view(HH, 1:min(istart + 2, iend), :), G')
    lmul!(G, τ)
    for i = istart:iend-2
        G, _ = givens(HH[i+1, i], HH[i+2, i], i + 1, i + 2)
        lmul!(G, view(HH, :, i:m))
        HH[i+2, i] = Htmp
        if i < iend - 2
            Htmp = HH[i+3, i+1]
            HH[i+3, i+1] = 0
        end
        rmul!(view(HH, 1:min(i + 3, iend), :), G')
        # mul!(G, τ)
    end
    return HH
end

function doubleShiftQR!(
    HH::StridedMatrix,
    τ::Rotation,
    shiftTrace::Number,
    shiftDeterminant::Number,
    istart::Integer,
    iend::Integer,
)
    m = size(HH, 1)
    H11 = HH[istart, istart]
    H21 = HH[istart+1, istart]
    Htmp11 = HH[istart+2, istart]
    HH[istart+2, istart] = 0
    if istart + 3 <= m
        Htmp21 = HH[istart+3, istart]
        HH[istart+3, istart] = 0
        Htmp22 = HH[istart+3, istart+1]
        HH[istart+3, istart+1] = 0
    else
        # values don't matter in this case but variables should be initialized
        Htmp21 = Htmp22 = Htmp11
    end
    G1, r = givens(
        H11 * H11 + HH[istart, istart+1] * H21 - shiftTrace * H11 + shiftDeterminant,
        H21 * (H11 + HH[istart+1, istart+1] - shiftTrace),
        istart,
        istart + 1,
    )
    G2, _ = givens(r, H21 * HH[istart+2, istart+1], istart, istart + 2)
    vHH = view(HH, :, istart:m)
    lmul!(G1, vHH)
    lmul!(G2, vHH)
    vHH = view(HH, 1:min(istart + 3, m), :)
    rmul!(vHH, G1')
    rmul!(vHH, G2')
    lmul!(G1, τ)
    lmul!(G2, τ)
    for i = istart:iend-2
        for j = 1:2
            if i + j + 1 > iend
                break
            end
            # G, _ = givens(H.H,i+1,i+j+1,i)
            G, _ = givens(HH[i+1, i], HH[i+j+1, i], i + 1, i + j + 1)
            lmul!(G, view(HH, :, i:m))
            HH[i+j+1, i] = Htmp11
            Htmp11 = Htmp21
            # if i + j + 2 <= iend
            # Htmp21 = HH[i + j + 2, i + 1]
            # HH[i + j + 2, i + 1] = 0
            # end
            if i + 4 <= iend
                Htmp22 = HH[i+4, i+j]
                HH[i+4, i+j] = 0
            end
            rmul!(view(HH, 1:min(i + j + 2, iend), :), G')
            # mul!(G, τ)
        end
    end
    return HH
end

_eigvals!(A::StridedMatrix; kwargs...) = _eigvals!(_schur!(A; kwargs...))
_eigvals!(H::HessenbergMatrix; kwargs...) = _eigvals!(_schur!(H; kwargs...))
_eigvals!(H::HessenbergFactorization; kwargs...) = _eigvals!(_schur!(H; kwargs...))

function LinearAlgebra.eigvals!(
    A::StridedMatrix;
    sortby::Union{Function,Nothing} = LinearAlgebra.eigsortby,
    kwargs...,
)

    if ishermitian(A)
        return LinearAlgebra.sorteig!(eigvals!(Hermitian(A)), sortby)
    end
    LinearAlgebra.sorteig!(_eigvals!(A; kwargs...), sortby)
end

LinearAlgebra.eigvals!(
    H::HessenbergMatrix;
    sortby::Union{Function,Nothing} = LinearAlgebra.eigsortby,
    kwargs...,
) = LinearAlgebra.sorteig!(_eigvals!(H; kwargs...), sortby)

LinearAlgebra.eigvals!(
    H::HessenbergFactorization;
    sortby::Union{Function,Nothing} = LinearAlgebra.eigsortby,
    kwargs...,
) = LinearAlgebra.sorteig!(_eigvals!(H; kwargs...), sortby)

# To compute the eigenvalue of the pseudo triangular Schur matrix we just return
# the values of the 1x1 diagonal blocks and compute the eigenvalues of the 2x2
# blocks on the fly. We can check for exact zeros in the subdiagonal because
# the QR algorithm sets the elements to zero when a split happens
function _eigvals!(S::Schur{T}; tol = eps(real(T))) where {T}
    HH = S.data
    n = size(HH, 1)
    vals = Vector{complex(T)}(undef, n)
    i = 1
    while i < n
        Hii = HH[i, i]
        if iszero(HH[i+1, i])
            # 1x1 block
            vals[i] = Hii
            i += 1
        else
            # 2x2 block
            Hi1i1 = HH[i+1, i+1]
            d = Hii * Hi1i1 - HH[i, i+1] * HH[i+1, i]
            t = Hii + Hi1i1
            x = 0.5 * t
            y = sqrt(complex(x * x - d))
            vals[i] = x + y
            vals[i+1] = x - y
            i += 2
        end
    end
    if i == n
        vals[i] = HH[n, n]
    end
    return vals
end

using Test, LinearAlgebra, Random
using GenericLinearAlgebra: cholUnblocked!, cholBlocked!, cholRecursive!

@testset "Cholesky" begin

    Random.seed!(123)

    n = 50

    @testset "element type: $T" for T in (Float32, Float64, BigFloat)
        @testset "is complex: $cplx" for cplx in (true, false)
            if cplx
                A = complex.(T.(rand(n, n)), T.(rand(n, n)))
            else
                A = T.(rand(n, n))
            end
            AcA = A'A
            @test LowerTriangular(cholUnblocked!(copy(AcA), Val{:L})) ≈
                  cholesky(Hermitian(AcA)).L
            @test LowerTriangular(cholBlocked!(copy(AcA), Val{:L}, 5)) ≈
                  cholesky(Hermitian(AcA)).L
            @test LowerTriangular(cholBlocked!(copy(AcA), Val{:L}, 10)) ≈
                  cholesky(Hermitian(AcA)).L
            @test LowerTriangular(cholRecursive!(copy(AcA), Val{:L}, 1)) ≈
                  cholesky(Hermitian(AcA)).L
            @test LowerTriangular(cholRecursive!(copy(AcA), Val{:L}, 4)) ≈
                  cholesky(Hermitian(AcA)).L
        end
    end
end

using LinearAlgebra
using LinearAlgebra: BlasComplex, BlasFloat, BlasReal, HermOrSym

import LinearAlgebra: lmul!, mul!

export rankUpdate!

# Rank one update

## General
### BLAS
rankUpdate!(
    A::StridedMatrix{T},
    x::StridedVector{T},
    y::StridedVector{T},
    α::T,
) where {T<:BlasReal} = BLAS.ger!(α, x, y, A)

### Generic
function rankUpdate!(A::StridedMatrix, x::StridedVector, y::StridedVector, α::Number)
    m, n = size(A, 1), size(A, 2)
    m == length(x) || throw(DimensionMismatch("x vector has wrong length"))
    n == length(y) || throw(DimensionMismatch("y vector has wrong length"))
    for j = 1:n
        yjc = y[j]'
        for i = 1:m
            A[i, j] += x[i] * α * yjc
        end
    end
end

## Hermitian
function rankUpdate!(
    A::HermOrSym{T,S},
    a::StridedVector{T},
    α::T,
) where {T<:BlasReal,S<:StridedMatrix}
    BLAS.syr!(A.uplo, α, a, A.data)
    return A
end
function rankUpdate!(
    A::Hermitian{Complex{T},S},
    a::StridedVector{Complex{T}},
    α::T,
) where {T<:BlasReal,S<:StridedMatrix}
    BLAS.her!(A.uplo, α, a, A.data)
    return A
end
rankUpdate!(A::HermOrSym{T,S}, a::StridedVector{T}) where {T<:BlasFloat,S<:StridedMatrix} =
    rankUpdate!(A, a, one(real(T)))

### Generic
function rankUpdate!(A::Hermitian, a::StridedVector, α::Real)
    n = size(A, 1)
    n == length(a) || throw(DimensionMismatch("a vector has wrong length"))
    @inbounds for j = 1:n
        ajc = a[j]'
        for i in ((A.uplo == 'L') ? (j:n) : (1:j))
            A.data[i, j] += a[i] * α * ajc
        end
    end
    return A
end

# Rank k update
## Real
function rankUpdate!(
    C::HermOrSym{T,S},
    A::StridedMatrix{T},
    α::T,
    β::T,
) where {T<:BlasReal,S<:StridedMatrix}
    BLAS.syrk!(C.uplo, 'N', α, A, β, C.data)
    return C
end

## Complex
function rankUpdate!(
    C::Hermitian{Complex{T},S},
    A::StridedMatrix{Complex{T}},
    α::T,
    β::T,
) where {T<:BlasReal,S<:StridedMatrix}
    BLAS.herk!(C.uplo, 'N', α, A, β, C.data)
    return C
end

### Generic
function rankUpdate!(C::Hermitian, A::StridedVecOrMat, α::Real)
    n = size(C, 1)
    n == size(A, 1) || throw(DimensionMismatch("first dimension of A has wrong size"))
    @inbounds if C.uplo == 'L' # branch outside the loop to have larger loop to optimize
        for k = 1:size(A, 2)
            for j = 1:n
                ajkc = A[j, k]'
                for i = j:n
                    C.data[i, j] += A[i, k] * α * ajkc
                end
            end
        end
    else
        for k = 1:size(A, 2)
            for j = 1:n
                ajkc = A[j, k]'
                for i = 1:j
                    C.data[i, j] += A[i, k] * α * ajkc
                end
            end
        end
    end
    return C
end

### Generic fallbacks
function lmul!(A::UpperTriangular{T,S}, B::StridedMatrix{T}, α::T) where {T<:Number,S}
    AA = A.data
    m, n = size(B)
    for i ∈ 1:m
        for j ∈ 1:n
            B[i, j] = α * AA[i, i] * B[i, j]
            for l ∈ (i+1):m
                B[i, j] += α * AA[i, l] * B[l, j]
            end
        end
    end
    return B
end
function lmul!(A::LowerTriangular{T,S}, B::StridedMatrix{T}, α::T) where {T<:Number,S}
    AA = A.data
    m, n = size(B)
    for i ∈ m:-1:1
        for j ∈ 1:n
            B[i, j] = α * AA[i, i] * B[i, j]
            for l ∈ 1:(i-1)
                B[i, j] += α * AA[i, l] * B[l, j]
            end
        end
    end
    return B
end
function lmul!(A::UnitUpperTriangular{T,S}, B::StridedMatrix{T}, α::T) where {T<:Number,S}
    AA = A.data
    m, n = size(B)
    for i ∈ 1:m
        for j ∈ 1:n
            B[i, j] = α * B[i, j]
            for l ∈ (i+1):m
                B[i, j] += α * AA[i, l] * B[l, j]
            end
        end
    end
    return B
end
function lmul!(A::UnitLowerTriangular{T,S}, B::StridedMatrix{T}, α::T) where {T<:Number,S}
    AA = A.data
    m, n = size(B)
    for i ∈ m:-1:1
        for j ∈ 1:n
            B[i, j] = α * B[i, j]
            for l ∈ 1:(i-1)
                B[i, j] += α * AA[i, l] * B[l, j]
            end
        end
    end
    return B
end
function lmul!(
    A::LowerTriangular{T,Adjoint{T,S}},
    B::StridedMatrix{T},
    α::T,
) where {T<:Number,S}
    AA = parent(A.data)
    m, n = size(B)
    for i ∈ m:-1:1
        for j ∈ 1:n
            B[i, j] = α * AA[i, i]' * B[i, j]
            for l ∈ 1:(i-1)
                B[i, j] += α * AA[l, i]' * B[l, j]
            end
        end
    end
    return B
end
function lmul!(
    A::UpperTriangular{T,Adjoint{T,S}},
    B::StridedMatrix{T},
    α::T,
) where {T<:Number,S}
    AA = parent(A.data)
    m, n = size(B)
    for i ∈ 1:m
        for j ∈ 1:n
            B[i, j] = α * AA[i, i]' * B[i, j]
            for l ∈ (i+1):m
                B[i, j] += α * AA[l, i]' * B[l, j]
            end
        end
    end
    return B
end
function lmul!(
    A::UnitLowerTriangular{T,Adjoint{T,S}},
    B::StridedMatrix{T},
    α::T,
) where {T<:Number,S}
    AA = parent(A.data)
    m, n = size(B)
    for i ∈ m:-1:1
        for j ∈ 1:n
            B[i, j] = α * B[i, j]
            for l ∈ 1:(i-1)
                B[i, j] += α * AA[l, i]' * B[l, j]
            end
        end
    end
    return B
end
function lmul!(
    A::UnitUpperTriangular{T,Adjoint{T,S}},
    B::StridedMatrix{T},
    α::T,
) where {T<:Number,S}
    AA = parent(A.data)
    m, n = size(B)
    for i ∈ 1:m
        for j ∈ 1:n
            B[i, j] = α * B[i, j]
            for l ∈ (i+1):m
                B[i, j] += α * AA[l, i]' * B[l, j]
            end
        end
    end
    return B
end

using Test
using LinearAlgebra
using GenericLinearAlgebra
using GenericLinearAlgebra: qrBlocked!

@testset "The QR decomposition" begin
    @testset "Problem dimension ($m,$n) with block size $bz" for (m, n) in (
            (10, 5),
            (10, 10),
            (5, 10),
            (100, 50),
            (100, 100),
            (50, 100),
        ),
        bz in (1, 2, 3, 4, 7, 8, 9, 15, 16, 17, 31, 32, 33)

        A = randn(m, n)
        Aqr = qrBlocked!(copy(A), bz)
        AqrQ = Aqr[Tuple{:QBlocked}]
        if m >= n
            @test (AqrQ'A)[1:min(m, n), :] ≈ Aqr[Tuple{:R}]
        else # For type stability getindex(,Tuple{:R}) throw when the output is trapezoid
            @test (AqrQ'A) ≈ triu(Aqr.factors)
        end
        @test AqrQ' * (AqrQ * A) ≈ A
    end

    @testset "Error paths" begin
        @test_throws DimensionMismatch LinearAlgebra.reflectorApply!(
            zeros(5, 5),
            zeros(4),
            1.0,
        )
        @test_throws ArgumentError qrBlocked!(randn(5, 10))[Tuple{:R}]
    end
end
